<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 20/08/14
 * Time: 17:58
 */

namespace Folha\Logic\ValesBeneficios\CalculoValeTransporte;

use Folha\Entities\FpaTipomoviment;
use \Folha\Entities\GpeVinculom;

use \Folha\Entities\GpeVinculoh;

use \Folha\Entities\GpeAlteescala;

use \Folha\Entities\GpeEscalatrabh;

use Folha\Entities\VabHistvalevinc;

use Folha\Entities\VabIntegtransph;

use \Folha\Repositories\FpaFerias;

use \Folha\Entities\FpaParamsindicato;

use \Folha\Entities\GpeAltesitufunc;

use Folha\Repositories\FpaValorreferenciam;
use \Geral\Repositories\Estruturah;

use \Folha\Repositories\GpeSitufunch;

use \Folha\Repositories\VabLinhavinc;

use \Folha\Repositories\GpeEscalatrabm;

use \Folha\Entities\GpeHorarioturno;

use \Folha\Repositories\FpaCalculofolha;

use HCM\Geral\Entity\GpemovimentacaoEntity;

use Geral\Util\Ambiente;

use \HCM\Util\DateUtil;

use Geral\Util\NovoCodigo;

use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\FPA;

use HCM\Util\MsgCalculo;

class ValeVinculo
{

    //CONSTANTES
    const SABADO = 6;
    const DOMINGO = 7;
    const SABDOM = 67;
    const SEGUNDA = 1;
    const TERCA = 2;
    const QUARTA = 3;
    const QUINTA = 4;
    const SEXTA = 5;

    //INFORMAÇÃO SOBRE O VÍNCULO
    private $objvinculo;
    private $objvinculoh;
    private $nrdiascomposicaomensal;
    private $nrdiasobrigacaosindicato;
    private $nrestrutlegal;

    private $nrtpjornada;
    private $nrturno;
    
    private $nrafastamento;
    private $nrfalta;
    private $nrdiasaviso;
    private $nrdiasferias;

    private $geraBenefFeriado;
    
    private $dsdiadescansosemanal;

    private $nrtipolinhavinc;

    private $idnaogeravale;

    private $diaInicialAupr;
    private $diaFinalAupr;
    
    private $idcalccomplementar;
    
    private $datasEntreAtestadoOuAfast;
    private $datasDsrAnt;
    private $datasFeriadosAnt;
    private $datasEntreFerias;
    private $dsrEntreFerias;
    private $feriadoEntreFerias;
    private $datasAposRescisao;
    private $datasFaltas;
    
    //INFORMAÇÕES SOBRE A LINHA
    private $passagens;
    private $vrtotal;
    private $vrrestante;

    //INFORMAÇÕES SOBRE O MÊS
    private $nrdiasproxmes;
    private $diastotaisconsideracao;
    private $datasDesconsideradas;
    private $datasEntre;
    private $qtdiasvalefixo;

    //INFORMAÇÕES DO SISTEMA
    private $nrorg;
    private $dtmescompetencia;
    private $dtiniperiodocalculo;
    private $dtfimperiodocalculo;
    private $dtiniperiodovale;
    private $dtfimperiodovale;
    
    //PARAMETRO DO VALE TRANSPORTE
    private $paramVale;

    /**
     * @var HCMParameters
     */
    private $hcmParameters;
    
    public $messages;
    
    //CONSTRUTOR
    /**
     * Construtor da Classe
     * @param GpeVinculom $objvinculo
     * @param int $nrorg
     * @param \DateTime $dtiniapuracao
     * @param \DateTime $dtfimapuracao
     * @param int $nrtipolinhavinc
     */
    public function __construct($objvinculo, $nrorg, \DateTime $dtiniapuracao, \DateTime $dtfimapuracao, $nrtipolinhavinc, $hcmParameters, $paramVale = null, $qtdiasvalefixo = null, $idcalccomplementar = 'N')
    {
        try {
            $this->idnaogeravale = false;
        
            $this->objvinculo = $objvinculo;
            $this->dtmescompetencia = $dtiniapuracao->format('01/m/Y');
            $this->nrorg = $nrorg;

            $dtiniperiodo = clone $dtiniapuracao;
            $dtfimperiodo = clone $dtfimapuracao;
            
            $this->_movimentosVinculo = new GpemovimentacaoEntity(\Setforms2\Shared\Registry::getEntityManager(), $hcmParameters);

//        //ÁREA CRIADA PARA A COMPENSAÇÃO DA NÃO UTILIZAÇÃO DE PERÍODO INICIAL E FINAL
//        //Para utilização de período, remova a variável $periodo e suas utilizações.
//        $periodo = DateUtil::getDataDeString($dtmescompetencia);
//        $periodo->add(new \DateInterval('P1M'));
//
//        $this->dtiniperiodovale = $dtiniperiodo = $periodo->format('d/m/Y');
//        $this->dtfimperiodovale = $dtfimperiodo = $periodo->format('t/m/Y');
//
//        //FINAL DE COMPENSAÇÃO
			
			if($dtiniperiodo <= $objvinculo->getDtadmissaovinc()){
                $dtiniperiodo = $objvinculo->getDtadmissaovinc();
            }
			
            $this->paramVale = $paramVale;
            $this->idcalccomplementar = $idcalccomplementar;

            $this->dtiniperiodovale = clone $dtiniperiodo;
            $this->dtfimperiodovale = clone $dtfimperiodo;

            $this->dtiniperiodocalculo = clone $dtiniperiodo;
            $this->dtfimperiodocalculo = clone $dtfimperiodo;

            /*$dtintervalo = $this->dtiniperiodocalculo->diff($this->dtfimperiodocalculo);
            $dtintervalo->d++;

            $this->dtiniperiodocalculo->sub($dtintervalo);
            $this->dtfimperiodocalculo->sub($dtintervalo);*/
            // felipesantos 08/07/2015 - Alteração para pegar o mês anterior às datas de apuração do vale
            $this->dtiniperiodocalculo->sub(new \DateInterval('P1M'));
            $this->dtfimperiodocalculo->sub(new \DateInterval('P1M'));
            
            $this->nrtipolinhavinc = $nrtipolinhavinc;
            
            $this->datasDesconsideradas = [];
            $this->datasAposRescisao = [];
            $this->datasEntreFerias = [];
            $this->dsrEntreFerias = [];
            $this->feriadoEntreFerias = [];
            $this->datasDsrAnt = []; 
            $this->datasFeriadosAnt = [];
            $this->datasFaltas = array();
            $this->datasEntreAtestadoOuAfast = [];
            $this->datasEntre = DateUtil::getDatasEntre($this->dtiniperiodovale, $this->dtfimperiodovale);
            
            $this->qtdiasvalefixo = $qtdiasvalefixo;
            $this->hcmParameters = $hcmParameters;
            $this->objvinculoh = $this->setVinculoh();
            $this->nrestrutlegal = $this->setNrestrutlegal();
            $this->nrdiascomposicaomensal = $this->setDiasComposicaoMensal();
            $this->nrdiasobrigacaosindicato = $this->setNrDiasObrigacaoSindicato();
            $this->setDecansoSemanal();
            $this->nrafastamento = $this->setNrAfastamento();
            $this->nrfalta = $this->setNrFalta();
            $this->nrdiasferias = $this->setNrDiasFerias($this->dtiniperiodovale, $this->dtfimperiodovale);
            $this->nrdiasproxmes = $this->setNrDiasCalculo($this->dtiniperiodovale, $this->dtfimperiodovale);
            $this->nrdiasaviso = $this->setNrDiasAviso($this->dtiniperiodovale, $this->dtfimperiodovale);
            
            $params = array(
                "P_REFERENCIA"     => 0,
                "P_NRORG"          => $nrorg,
                "P_DTMESCOMPETENC" => $this->dtmescompetencia,
                "P_DSREFERENCIA"   => 'DESCONTA_FALTA_VALE');

            $sql = "select * from FPA_VALORREFERENCIAM
                      JOIN FPA_VALORREFERENCIAH
                        ON FPA_VALORREFERENCIAH.NRVALORREFERENCIAM = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                       AND FPA_VALORREFERENCIAH.VRREFERENCIA = :P_REFERENCIA
                       AND FPA_VALORREFERENCIAH.DTMESCOMPETENC =
                                                             (SELECT MAX(DTMESCOMPETENC)
                                                                FROM FPA_VALORREFERENCIAH
                                                               WHERE FPA_VALORREFERENCIAH.NRVALORREFERENCIAM       = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                                                                 AND FPA_VALORREFERENCIAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))

                    WHERE FPA_VALORREFERENCIAM.NRORG = :P_NRORG
                    AND FPA_VALORREFERENCIAM.DSREFERENCIA = :P_DSREFERENCIA";

            $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
            
            MemoriaVT::getInstance()->setDiasConsPeriodo($this->nrdiasproxmes);
            MemoriaVT::getInstance()->setDiasComposicaoMensal($this->nrdiascomposicaomensal);
            MemoriaVT::getInstance()->setDiasObrigacaoSindicato($this->nrdiasobrigacaosindicato);
            MemoriaVT::getInstance()->setDiasAfastAtest($this->nrafastamento);
            MemoriaVT::getInstance()->setFaltas($this->nrfalta);
            MemoriaVT::getInstance()->setFerias($this->nrdiasferias);
            MemoriaVT::getInstance()->setDiasAviso($this->nrdiasaviso);

            if (empty($retorno)) {
                MemoriaVT::getInstance()->setReferencia(false);
                if($this->idcalccomplementar == 'S'){
                    $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal;
                } elseif ($this->nrdiascomposicaomensal) {
                    $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
                } elseif ($this->nrdiasobrigacaosindicato) {
                    $this->diastotaisconsideracao = (int)$this->nrdiasobrigacaosindicato - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
                } elseif ($this->nrdiasaviso) {
                    $this->diastotaisconsideracao = (int)$this->nrdiasaviso - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
                } else {
                    $this->diastotaisconsideracao = (int)$this->nrdiasproxmes - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
                }
            }else{
                MemoriaVT::getInstance()->setReferencia(true);
                if ($this->nrdiascomposicaomensal) {
                    $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal;
                } elseif ($this->nrdiasobrigacaosindicato) {
                    $this->diastotaisconsideracao = (int)$this->nrdiasobrigacaosindicato;
                } elseif ($this->nrdiasaviso) {
                    $this->diastotaisconsideracao = (int)$this->nrdiasaviso;
                } else {
                    $this->diastotaisconsideracao = (int)$this->nrdiasproxmes;
                }
            }

            if ($this->idnaogeravale) {
                MemoriaVT::getInstance()->setIdNaoGeraCalc($this->idnaogeravale);
                $this->diastotaisconsideracao = 0;
            }
            
            MemoriaVT::getInstance()->setResultadoTotal($this->diastotaisconsideracao);
            
            $this->setPassagens();

        }catch (\Exception $e){
            throw $e;
        }

    }
    
    public function getMessages(){
        return $this->messages;
    }

    //INFORMAÇÃO SOBRE O VÍNCULO
    /**
     * VERIFICA A QUANTIDADE DE DIAS DA COMPOSIÇÃO MENSAL DO VÍNCULO
     * Verifica a quantidade de dias da composição mensal de cada vínculo. Criado para tratar excessões, quando
     * vínculos tem uma excessão no pagamento de seus vales transporte
     */
    private function setDiasComposicaoMensal()
    {
        empty($this->qtdiasvalefixo) ? $nrDiasApurVale = $this->objvinculo->getNrdiasapurvales() : $nrDiasApurVale = $this->qtdiasvalefixo;
        return (int) $nrDiasApurVale;
    }

    /**
     * VERIFICA A QUANTIDADE DE DIAS OBRIGATÓRIOS POR ACORDO COM O SINDICATO
     * Opção feita quando se há uma quantidade de vales a ser depositado por algum acordo entre o sindicato patronal e
     * o sindicato operário.
     */
    private function setNrDiasObrigacaoSindicato()
    {
        $dtmescompetencia = $this->dtmescompetencia;
        $nrDiasApurVale = null;

        if ($this->objvinculoh->getNrestrutsind()) {
            $params = array(
                'P_NRESTRUTURAM' => $this->objvinculoh->getNrestrutsind(),
                'P_NRORG' => $this->nrorg
            );
            $where = "NRESTRUTURAM = :P_NRESTRUTURAM AND NRORG = :P_NRORG AND DTINICIOVIGENCIA <= '$dtmescompetencia' AND (DTFIMVIGENCIA >= '$dtmescompetencia' OR DTFIMVIGENCIA IS NULL)";
            $sindicato = FpaParamsindicato::getObjectByWhere($where, $params);

            if($sindicato) $nrDiasApurVale = (int)$sindicato->getNrdiasapurvales();
        }
        
        return $nrDiasApurVale;
    }

    /**
     * VERIFICA A QUANTIDADE DE DIAS QUE SERÁ DEPOSITADO DE ACORDO COM A ESCALA DE TRABALHO.
     * Opção feita para aquelas pessoas que trabalham com uma escala de trabalho onde é difícil se definir quando será
     * seus dias de descanso remunerado
     */
    private function setDecansoSemanal()
    {
        $this->dsdiadescansosemanal = self::SABDOM;
        
        $competencia = $this->dtmescompetencia;
        $iniperiodo = clone $this->dtiniperiodovale;
        $fimperiodo = clone $this->dtfimperiodovale;

        try {
            /**
             * @var GpeEscalatrabh $escalaTrab
             * @var GpeAlteescala $escalaTrabVinc
             */
            $params = array(    
                            'P_NRORG' => $this->nrorg,
                            'P_NRVINCULOM' => $this->objvinculo->getNrvinculom(),
                            'P_INIPERIODO' => $iniperiodo->format('d/m/Y'),
                            'P_FIMPERIODO' => $fimperiodo->format('d/m/Y'),
                            'P_COMPETENCIA' => $competencia,
                           );
            $where = "e.NRVINCULOM = :P_NRVINCULOM 
                        AND e.NRORG = :P_NRORG 
                        AND :P_INIPERIODO BETWEEN e.DTINIESCALA AND NVL(e.DTFIMESCALA, :P_FIMPERIODO) 
                        AND e.DTINIESCALA = (SELECT MAX(DTINIESCALA) DTINIESCALA 
                                                FROM GPE_ALTEESCALA MAX_ALTEESCALA 
                                                WHERE MAX_ALTEESCALA.DTINIESCALA <= :P_COMPETENCIA 
                                                AND MAX_ALTEESCALA.NRORG = e.NRORG 
                                                AND MAX_ALTEESCALA.NRVINCULOM = e.NRVINCULOM
                                           )";
            $escalaTrabVinc = GpeAlteescala::getObjectByWhere($where, $params);
            
            $this->nrturno = isset($escalaTrabVinc) && !empty($escalaTrabVinc) ? $escalaTrabVinc->getNrturno() : null; // Caso haja turno a contagem de dias deverá olhar apenas para o turno

            if ($escalaTrabVinc) {
                $params = array(
                    'P_NRORG' => $this->nrorg,
                    'P_NRESCALATRABM' => $escalaTrabVinc->getNrescalatrabm(), 
                    'P_DTMESCOMPETENC' => $competencia, 
                );
                $where = "NRORG = :P_NRORG 
                            AND e.NRESCALATRABM = :P_NRESCALATRABM 
                            AND e.DTMESCOMPETENC = (SELECT MAX(MAX_ESCALATRABH.DTMESCOMPETENC) 
                                                    FROM GPE_ESCALATRABH MAX_ESCALATRABH 
                                                    WHERE MAX_ESCALATRABH.DTMESCOMPETENC <= :P_DTMESCOMPETENC 
                                                    AND MAX_ESCALATRABH.NRESCALATRABM = e.NRESCALATRABM 
                                                    AND MAX_ESCALATRABH.NRORG = e.NRORG
                                                  )";
                $escalatrabalho = GpeEscalatrabh::getObjectByWhere($where, $params);
                // histórico é carregado novamente apenas para acessar os valores 'IDGERBENFER' e 'IDUTAPURATESTBENEF' 
                $historico = GpeEscalatrabm::_retornaHistórico(
                    $escalatrabalho->getNrescalatrabh(), 
                    $this->hcmParameters->getNrorgTrabalho()
                );
                $this->geraBenefFeriado = isset($escalatrabalho) && $escalatrabalho->getIdgerbenfer() ? $escalatrabalho->getIdgerbenfer() : null;
                $this->geraBenefFeriado = isset($historico) && !empty($historico) ? $historico['IDGERBENFER'] : null;

                if(isset($historico['IDUTAPURATESTBENEF']) && !empty($historico['IDUTAPURATESTBENEF']) && ($historico['IDUTAPURATESTBENEF'] == 'S' || $historico['IDUTAPURATESTBENEF'] == 'Y')){
                    $this->diaInicialAupr = $escalatrabalho->getNrdiainiapur();
                    $this->diaFinalAupr = $escalatrabalho->getNrdiafinapur();
                }                
                
                // $this->nrtpjornada = isset($escalatrabalho) && !empty($escalatrabalho) ? $escalatrabalho->getNrtpjornada() : null;

                $dsdescansosemanal = $escalatrabalho->getDescansosemanal();
                switch ($dsdescansosemanal) {
                    case('SABADO'): {
                        $this->dsdiadescansosemanal = self::SABADO;
                        break;
                    }
                    case('SAB/DOM'): {
                        $this->dsdiadescansosemanal = self::SABDOM;
                        break;
                    }
                    case('DOMINGO'): {
                        $this->dsdiadescansosemanal = self::DOMINGO;
                        break;
                    }
                    case('SEGUNDA'): {
                        $this->dsdiadescansosemanal = self::SEGUNDA;
                        break;
                    }
                    case('TERCA'): {
                        $this->dsdiadescansosemanal = self::TERCA;
                        break;
                    }
                    case('QUARTA'): {
                        $this->dsdiadescansosemanal = self::QUARTA;
                        break;
                    }
                    case('QUINTA'): {
                        $this->dsdiadescansosemanal = self::QUINTA;
                        break;
                    }
                    case('SEXTA'): {
                        $this->dsdiadescansosemanal = self::SEXTA;
                        break;
                    }
                    case('6 X 1'): {
                        $this->dsdiadescansosemanal = self::DOMINGO;
                        break;
                    }
                    case('ESCALA'): {
                        $this->dsdiadescansosemanal = self::DOMINGO;
                        break;
                    }
                }
                
            }
            else {
                //throw new \Exception('Vínculo '.$this->objvinculo->getNrvinculom().' - '.$this->objvinculo->getNmvinculom().' não possui escala.');
            }
        }catch (\Exception $e){
            throw $e;
        }
    }

    /**
     * NÚMERO DE AFASTAMENTOS QUE O VÍNCULO OBTEVE DURANTE DO PERÍODO
     * Considera-se o número de dias em que o vínculo de afastou da empresa e tais afastamentos não geraram vales
     * transporte, tais como atestados médicos, afastamento por acidente (de trabalho ou não), afastamento por gravidez,
     * afastamentos por serviços sociais (militares ou parecidos).
     */
    private function setNrAfastamento()
    {
        //felipesantos - 09/06/2015 : Alterações para considerar o período de apuração do vale e caso as datas de afastamento não estejam compreendidas dentro do período
        //                            considerar as datas do período de apuração.
        //felipesantos - 05/10/2015 : Alterado para considerar os afastamentos voltando dois períodos de apuração do vale, pois é o período que se encontra totalmente fechado.
        //                            Por exemplo: para apuração de 16/09 a 15/10, considerar os afastamentos em 16/07 a 15/08.
        $dtiniperiodo    = clone $this->dtiniperiodocalculo;
        $dtfimperiodo    = clone $this->dtfimperiodocalculo;
        $dtiniperiodoAnt = clone $this->dtiniperiodocalculo;
        $dtfimperiodoAnt = clone $this->dtfimperiodocalculo;
        $dtiniperiodoAnt = $dtiniperiodoAnt->sub(new \DateInterval('P1M'));
        $dtfimperiodoAnt = $dtfimperiodoAnt->sub(new \DateInterval('P1M'));
        // Caso seja para contar dias de Atestado e na escala do vínculo tenha período pré-definido e id 'Utiliza para Atestados' preenchido,
        // função abaixo adequará perído de consideração de atestado segundo o informado no histórico da Escala do vínculo
        if($this->diaInicialAupr && $this->diaFinalAupr) $this->setPeriodoApuracaoPelaEscala($dtiniperiodoAnt, $dtfimperiodoAnt);

        
        $nrsitufuncm = GpeSitufunch::getAfastamentoIncideVale($this->dtmescompetencia);
        $nrsitufuncm = implode(', ', $nrsitufuncm);
        $total = 0;
        $where = "NRORG = :P_NRORG AND
                  NRVINCULOM = :P_NRVINCULOM AND
                  (
                       /*AFASTAMENTO*/ (DTINISITUFUNC <= '$dtfimperiodo' AND DTFIMSITUFUNC >= '$dtiniperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13)) OR
                       /*AFASTAMENTO*/ (DTINISITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13)) OR
                       /*AFASTAMENTO*/ (DTFIMSITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13)) OR
                       /*ATESTADO*/    (DTINISITUFUNC <= '$dtfimperiodoAnt' AND DTFIMSITUFUNC >= '$dtiniperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16)) OR
                       /*ATESTADO*/    (DTINISITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16)) OR
                       /*ATESTADO*/    (DTFIMSITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16)) OR
                                       (DTFIMSITUFUNC IS NULL) OR
                       /*AFASTAMENTO*/ (DTINISITUFUNC = (SELECT MAX(DTINISITUFUNC)
                                                                FROM GPE_ALTESITUFUNC MAX_ALTESITUFUNC
                                                                WHERE MAX_ALTESITUFUNC.NRORG = e.NRORG
                                                                AND MAX_ALTESITUFUNC.NRVINCULOM = e.NRVINCULOM) AND NRSITUFUNCM NOT IN (12, 15, 16)
                                        )
                   ) AND NRSITUFUNCM IN ($nrsitufuncm)";
        $param = array(
            'P_NRORG' => $this->nrorg,
            'P_NRVINCULOM' => $this->objvinculo->getNrvinculom());
        //$altesitfuncs = GpeAltesitufunc::getObjectsByWhere("NRORG = :P_NRORG AND NRVINCULOM = :P_NRVINCULOM AND ((DTINISITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo') OR (DTFIMSITUFUNC IS NULL OR DTFIMSITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo')) AND NRSITUFUNCM IN ($nrsitufuncm)",$param);
        $altesitfuncs = GpeAltesitufunc::getObjectsByWhere($where, $param);
        
        foreach($altesitfuncs as $altesitfunc){
			if (($altesitfunc->getNrsitufuncm() == 12) or ($altesitfunc->getNrsitufuncm() == 15) or ($altesitfunc->getNrsitufuncm() == 16)) {
				if ($altesitfunc->getDtinisitufunc() < $dtiniperiodoAnt) {
					$dtiniafastamento = $dtiniperiodoAnt;
				} else {
					$dtiniafastamento = $altesitfunc->getDtinisitufunc();
				}
				if (!$altesitfunc->getDtfimsitufunc()) {
					//Caso a situação funcional não possual data final, considera o dia anterior da data inicial da próxima situação que gera vale
					$dtinisitufunc = $altesitfunc->getDtinisitufunc();
					$where = "NRORG = :P_NRORG AND
							  NRVINCULOM = :P_NRVINCULOM AND
							  DTINISITUFUNC > '$dtinisitufunc' AND
							  DTINISITUFUNC <= '$dtfimperiodoAnt' AND
							  NRSITUFUNCM NOT IN ($nrsitufuncm)";
					$param = array(
						'P_NRORG' => $this->nrorg,
						'P_NRVINCULOM' => $this->objvinculo->getNrvinculom());
					$prox_altesitufunc = GpeAltesitufunc::getObjectsByWhere($where, $param);

					if ($prox_altesitufunc) {
						//Dia anterior da próxima situação geradora de vale
						$dtfimafastamento = end($prox_altesitufunc)->getDtinisitufunc()->sub(new \DateInterval('P1D'));
						//Caso o afastamento não esteja no período de apuração, é desconsiderado
						if ($dtfimafastamento < $dtiniafastamento) {
							continue;
						}
					} else {
						//Caso não tenha próxima situação que gera vale considera a data final do periodo de apuração
						$dtfimafastamento = clone $dtfimperiodoAnt;
					}

				} else {
					if ($altesitfunc->getDtfimsitufunc() > $dtfimperiodoAnt) {
						$dtfimafastamento = $dtfimperiodoAnt;
					} else {
						$dtfimafastamento = $altesitfunc->getDtfimsitufunc();
					}
				}

                if (($dtiniafastamento == $dtiniperiodoAnt) and ($dtfimafastamento == $dtfimperiodoAnt)) {
                    $this->idnaogeravale = true;
                }
			} else {
				if ($altesitfunc->getDtinisitufunc() < $dtiniperiodo) {
					$dtiniafastamento = $dtiniperiodo;
				} else {
					$dtiniafastamento = $altesitfunc->getDtinisitufunc();
				}
				if (!$altesitfunc->getDtfimsitufunc()) {
					//Caso a situação funcional não possual data final, considera o dia anterior da data inicial da próxima situação que gera vale
					$dtinisitufunc = $altesitfunc->getDtinisitufunc();
					$where = "NRORG = :P_NRORG AND
							  NRVINCULOM = :P_NRVINCULOM AND
							  DTINISITUFUNC > '$dtinisitufunc' AND
							  DTINISITUFUNC <= '$dtfimperiodo' AND
							  NRSITUFUNCM NOT IN ($nrsitufuncm)";
					$param = array(
						'P_NRORG' => $this->nrorg,
						'P_NRVINCULOM' => $this->objvinculo->getNrvinculom());
					$prox_altesitufunc = GpeAltesitufunc::getObjectsByWhere($where, $param);

					if ($prox_altesitufunc) {
						//Dia anterior da próxima situação geradora de vale
						$dtfimafastamento = end($prox_altesitufunc)->getDtinisitufunc()->sub(new \DateInterval('P1D'));
						//Caso o afastamento não esteja no período de apuração, é desconsiderado
						if ($dtfimafastamento < $dtiniafastamento) {
							continue;
						}
					} else {
						//Caso não tenha próxima situação que gera vale considera a data final do periodo de apuração
						$dtfimafastamento = clone $dtfimperiodo;
					}

				} else {
					if ($altesitfunc->getDtfimsitufunc() > $dtfimperiodo) {
						$dtfimafastamento = $dtfimperiodo;
					} else {
						$dtfimafastamento = $altesitfunc->getDtfimsitufunc();
					}
				}

                if (($dtiniafastamento == $dtiniperiodo) and ($dtfimafastamento == $dtfimperiodo)) {
                    $this->idnaogeravale = true;
				}
			}
			
            if ($dtfimafastamento >= $dtiniafastamento) {
                
				$qnt = $dtiniafastamento->diff($dtfimafastamento, true);
				
				$this->datasEntreAtestadoOuAfast = DateUtil::getDatasEntre($dtiniafastamento, $dtfimafastamento);
				
				//Datas em string 
			    $this->datasFeriadosAnt = $this->seekFeriado($dtiniafastamento, $dtfimafastamento);
			    $this->datasDsrAnt = $this->seekDsr($dtiniafastamento, $dtfimafastamento, $this->dsdiadescansosemanal);
				
                $diasTotaisAtestOuAfast = ($qnt->d + $qnt->m*30 + $qnt->y*365 + 1);
                
    			$arFeriados = $this->seekFeriado($dtiniafastamento->format('d/m/Y'), $dtfimafastamento->format('d/m/Y'));
    			$feriados = count($arFeriados);
                
                if( isset($this->nrturno) ){
                    $arrayDiasFolgaVinc = $this->calcularQtdeDiasFolgaVinc($dtiniafastamento, $qnt, $this->objvinculo->getNrvinculom(), $this->nrturno);
                    $diasFolga = count($arrayDiasFolgaVinc);
                    $intersecaoFolgaFeriado = count(array_intersect($arrayDiasFolgaVinc, $arFeriados)); //quantidade de dias que coincidem Atestado/Afastamento e Feriados
                    $total += $resultado = $diasTotaisAtestOuAfast - $feriados - $diasFolga + $intersecaoFolgaFeriado;
                    
                    MemoriaVT::getInstance()->detalharDiasAfastAtest(
                        array(
                            'tipo' => 'turno',
                            'dtInicial' => $dtiniafastamento->format('d/m/Y'),
                            'dtFinal' => $dtfimafastamento->format('d/m/Y'),
                            "formula" => "resultado = diasTotaisAtestOuAfast - feriados - diasFolga + intersecaoFolgaFeriado",
                            "expressao" => $resultado.' = '.$diasTotaisAtestOuAfast.' - '.$feriados.' - '.$diasFolga.' + '.$intersecaoFolgaFeriado,  
                            "resultado" => $resultado,
                            "diasTotaisAtestOuAfast" => $diasTotaisAtestOuAfast,
                            "feriados" => $feriados,
                            "diasFolga" => $diasFolga,
                            "intersecaoFolgaFeriado" => $intersecaoFolgaFeriado,
                        )
                    );
                }else{
    				$arDsr      = $this->seekDsr($dtiniafastamento->format('d/m/Y'), $dtfimafastamento->format('d/m/Y'), $this->dsdiadescansosemanal); 
    				$dsr      = count($arDsr);
    				$intersecaoDsrFeriado = count(array_intersect($arDsr, $arFeriados)); //quantidade de dias que coincidem DSR e Feriados
    				$total += $resultado = $diasTotaisAtestOuAfast - $feriados - $dsr + $intersecaoDsrFeriado;
                    
                    MemoriaVT::getInstance()->detalharDiasAfastAtest(
                        array(
                            'tipo' => 'dsr', 
                            'dtInicial' => $dtiniafastamento->format('d/m/Y'),
                            'dtFinal' => $dtfimafastamento->format('d/m/Y'),
                            "formula" => "resultado = diasTotaisAtestOuAfast - feriados - dsr + intersecaoDsrFeriado",
                            "expressao" => $resultado.' = '.$diasTotaisAtestOuAfast.' - '.$feriados.' - '.$dsr.' + '.$intersecaoDsrFeriado,  
                            "resultado" => $resultado,
                            "diasTotaisAtestOuAfast" => $diasTotaisAtestOuAfast,
                            "feriados" => $feriados,
                            "dsr" => $dsr,
                            "intersecaoDsrFeriado" => $intersecaoDsrFeriado,
                        )
                    );
                }
			}
        }
        
        return $total;
    }

    private function setPeriodoApuracaoPelaEscala(&$dtiniperiodoAnt, &$dtfimperiodoAnt){ 
        $competenciaReferencia = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);

        // Subtrari dois meses da competência para operar de acordo com a data final evidente na tela de escala
        $competenciaReferencia = $competenciaReferencia->sub(new \DateInterval('P2M')); 
        $dtfimperiodoAnt = clone $competenciaReferencia;
        $dtfimperiodoAnt = $dtfimperiodoAnt->add(new \DateInterval('P'. ($this->diaFinalAupr-1).'D'));
        
        // Subtrai mais um mes para operar de acordo com a data inicial evidente na tela de escala
        $competenciaReferencia = $competenciaReferencia->sub(new \DateInterval('P1M')); 
        $dtiniperiodoAnt = clone $competenciaReferencia;
        $dtiniperiodoAnt = $dtiniperiodoAnt->add(new \DateInterval('P'. ($this->diaInicialAupr-1).'D'));
    }
    
    public function retornaArraySituFuncFaltas($nrsitufuncm, $dtInicio, $dtFim){
        $arraySituFuncFaltas = [];

        $where = "NRORG = :P_NRORG AND
                  NRVINCULOM = :P_NRVINCULOM AND
                  DTINISITUFUNC >= '$dtInicio' AND DTFIMSITUFUNC <= '$dtFim' AND NRSITUFUNCM = :P_NRSITUFUNCM";
                       
        $param = array(
            'P_NRORG' => $this->nrorg,
            'P_NRVINCULOM' => $this->objvinculo->getNrvinculom(),
            'P_NRSITUFUNCM' => $nrsitufuncm);
    
        $altesitfuncs = GpeAltesitufunc::getObjectsByWhere($where, $param);
        
        foreach($altesitfuncs as $altesitfunc){
            array_push($arraySituFuncFaltas, $altesitfunc);
        }
        
        return $arraySituFuncFaltas;
    }
    
    private function calculaFaltasSituFunc($situfuncs){
        $faltasSituFunc = 0;
        
        foreach($situfuncs as $falta){
            //Verificar se a data fim e maior do q a data inicio
            if($falta->getDtfimsitufunc() > $falta->getDtinisitufunc()){
                //Calcula a diferença de dias entre essas datas.
                $qntDiasFaltasSitu = $falta->getDtinisitufunc()->diff($falta->getDtfimsitufunc(), true)->d+1;
                $faltasSituFunc = $faltasSituFunc + $qntDiasFaltasSitu;
            } else {
                //Se caso a data fim for igual a data inicio adiciona somente uma falta.
                $faltasSituFunc++;
            }
        }
        return $faltasSituFunc;
    }
    
    private function getFaltasFrequencia($nrorg, $nrvinculom, $dtIni, $dtFim, $nrorgpadrao){
        $params = array(
            "P_NRORG"          => $nrorg,
            "P_NRVINCULOM"     => $nrvinculom,
            "P_DTINICIOAPUR"   => $dtIni,
            "P_DTFIMAPUR"      => $dtFim,
            "P_NRORG_PADRAO"   => $nrorgpadrao
            );

$sql = "SELECT
    resusitu.NRORG,
    resusitu.NRVINCULOM,
    resusitu.DTAPURACAOSITUFREQ,
    resusitu.QTREFAPURSITUFREQ,
    resusitu.NRSITUFREQUENCIA,
    situfreq.NRCALCULOSITUFREQ
FROM PTO_RESUMOSITUFREQ resusitu
JOIN PTO_ASSOCSITUFREQ situfreq
ON situfreq.NRSITUFREQUENCIA = resusitu.NRSITUFREQUENCIA
AND situfreq.NRORG = (
    SELECT NRORG
    FROM PTO_ASSOCSITUFREQ
    WHERE NRSITUFREQUENCIA = situfreq.NRSITUFREQUENCIA
        AND (NRORG = :P_NRORG OR NRORG = :P_NRORG_PADRAO)
    GROUP BY NRORG
    ORDER BY (
        CASE
            WHEN NRORG = :P_NRORG AND COUNT(NRORG) = 1 THEN -1
            ELSE NRORG
        END
    )
    FETCH FIRST ROW ONLY
)
AND situfreq.NRASSOCSITUFREQ = (
    SELECT MAX(NRASSOCSITUFREQ)
    FROM PTO_ASSOCSITUFREQ
    WHERE NRORG = situfreq.NRORG
        AND NRSITUFREQUENCIA = situfreq.NRSITUFREQUENCIA
)
AND situfreq.NRCALCULOSITUFREQ IN(10600, 10500)
WHERE resusitu.NRORG = :P_NRORG 
        AND resusitu.NRSITUFREQUENCIA = situfreq.NRSITUFREQUENCIA 
        AND resusitu.NRVINCULOM = :P_NRVINCULOM 
        AND resusitu.DTAPURACAOSITUFREQ BETWEEN :P_DTINICIOAPUR AND :P_DTFIMAPUR";

        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        
        return $retorno;
    }
    
    private function calculaFaltasFrequencia($arrayFaltasFreq){
        $dataFaltaAnterior = '';
        $qtdeFaltas = 0;

        for($indice = 0; $indice < count($arrayFaltasFreq); $indice++){
            /*Considerando que o retorno do array pode vir com 2 Posições com a mesma data, contamos somente uma (Pode acontecer de vir o numero 7 no campo ['QTREFAPURSITUFREQ']
            e logo apos com a mesma data, outro registro com o campo ['QTREFAPURSITUFREQ'] igual a 1, o que totaliza 8 horas de falta.)
            Segundo o proprio vinicius, foi dito que quando aparecer uma situação destas considera-se uma falta somente.*/
            if($arrayFaltasFreq[$indice]['DTAPURACAOSITUFREQ'] == $dataFaltaAnterior){
                continue;
            }
            
            $qtdeFaltas++;
            $dataFaltaAnterior = $arrayFaltasFreq[$indice]['DTAPURACAOSITUFREQ'];
        }

        return $qtdeFaltas;
    }

    /**
     * NÚMERO DE FALTAS
     * Considera-se faltas não justificadas durante o período avaliado.
     */
    private function setNrFalta()
    {
        $dtIniPeriodoFalta = clone $this->dtiniperiodovale;
        $dtFimPeriodoFalta = clone $this->dtfimperiodovale;
        $qtdeFaltas = 0;
        $nreventom = "490, 495, 1040, 1043";
        $nrtpmovimento = '1';
        
        if(!empty($this->paramVale)){
            if($this->paramVale['IDCONSFALTAVALE'] == 'S'){
                $dataRetrocedidaIni = DateUtil::truncateData($dtIniPeriodoFalta)->sub(new \DateInterval("P". $this->paramVale['QTMESESFALTAVALE'] ."M"));
                $dataRetrocedidaFim = DateUtil::truncateData($dtFimPeriodoFalta)->sub(new \DateInterval("P". $this->paramVale['QTMESESFALTAVALE'] ."M"));
                $dataRetrocedidaComp = DateUtil::truncateData(DateUtil::getPrimeiroDiaDoMes($dtIniPeriodoFalta))->sub(new \DateInterval("P". $this->paramVale['QTMESESFALTAVALE'] ."M"));
                
                //Antes de buscar as datas das faltas do vinculo, precisamos verificar se a dataRetrocedidaFim e maior q o ultimo dia do mes da competencia retrocedida...
                $UltimoDiaDataRetrocedida = DateUtil::truncateData(DateUtil::getUltimoDiaDoMes($dataRetrocedidaComp));
                if($dataRetrocedidaFim > $UltimoDiaDataRetrocedida){
                    $dataRetrocedidaFim = $UltimoDiaDataRetrocedida;
                }
                
                switch($this->paramVale['IDORIGVALEFALTA']){
                    case "1":
                        //Calculo de VT Utilizando a origem de faltas pela folha usando os eventos 490,495,1040,1043 no mes da competencia retrocedida para o vinculo...
                        $qtdeFaltas = $this->calculaQtdeDiasFaltas($this->objvinculo->getNrvinculom(), $this->nrorg, $dataRetrocedidaIni, $dataRetrocedidaFim, $nreventom, $nrtpmovimento, $dataRetrocedidaComp);
                        
                        return $qtdeFaltas;
                        break;
                    case "2":
                        //Calculo de VT utilizando origem de faltas pela situação funcional falta(DIA) no periodo retrocedido.
                        $arraySituFuncFaltas = $this->retornaArraySituFuncFaltas(100072, $dataRetrocedidaIni, $dataRetrocedidaFim);
                        
                        $descansoRemuneradoEFeriado = array();
                        $descansos = array();
                        $feriados = array();
 
                        if(!empty($arraySituFuncFaltas)){
                            foreach($arraySituFuncFaltas as $arraySituFuncFalta){
                                
                                $descansos = $this->seekDsr($arraySituFuncFalta->getDtinisitufunc(), $arraySituFuncFalta->getDtfimsitufunc());
                                $feriados = $this->seekFeriado($arraySituFuncFalta->getDtinisitufunc(), $arraySituFuncFalta->getDtfimsitufunc());
                                
                                $datasEntrefaltas = DateUtil::getDatasEntre($arraySituFuncFalta->getDtinisitufunc(), $arraySituFuncFalta->getDtfimsitufunc());
                                foreach($datasEntrefaltas as $falta){
                                    //Array de faltas para utilizar na rotina de vale com dia de semanas marcados.
                                    //Não coloca dentro do datasFaltas, os feriados e nem os DSR's somente as faltas do vinculo de fato.
                                    if(!in_array($falta->format('d/m/Y'), $descansos) && !in_array($falta->format('d/m/Y'), $feriados) && !in_array($falta->format('d/m/Y'), $this->datasFaltas)){
                                        $this->datasFaltas[] = $falta->format('d/m/Y');
                                    }
                                }
                                
                                if(!empty($descansos)){
                                    foreach($descansos as $descanso){
                                        if(!in_array($descanso, $descansoRemuneradoEFeriado)){
                                            $descansoRemuneradoEFeriado[] = $descanso;
                                        }
                                    }
                                }
                                
                                if(!empty($feriados)){
                                    foreach($feriados as $feriado){
                                        if(!in_array($feriado, $descansoRemuneradoEFeriado)){
                                            $descansoRemuneradoEFeriado[] = $feriado;
                                        }
                                    }
                                }
                            }
                            
                            $qtdeFaltas = $this->calculaFaltasSituFunc($arraySituFuncFaltas);
                        }
                        
                        //Pega a quantidade de DSRs do vinculo, no periodo da situação funcional das faltas e diminui da quantidade de faltas.
                        if($qtdeFaltas >= count($descansoRemuneradoEFeriado)){
                            $qtdeFaltas = $qtdeFaltas - count($descansoRemuneradoEFeriado);
                        } else {
                            //Se o vinculo tiver DSR's + Feriados maior do que faltas a quantidade de faltas devem ser 0.
                            $qtdeFaltas = 0;
                        }
                        
                        return $qtdeFaltas ;
                        break;
                    case "3":
                        //Calculo de VT utilizando origem de faltas pelo Modulo Frequencia.
                        $arrayFaltasFreq = $this->getFaltasFrequencia($this->nrorg, $this->objvinculo->getNrvinculom(), $dataRetrocedidaIni->format('d/m/Y'), $dataRetrocedidaFim->format('d/m/Y'), 0);

                        if(!empty($arrayFaltasFreq)){
                            foreach($arrayFaltasFreq as $faltaFreq){
                                if(!in_array(DateUtil::getDataDeString($faltaFreq['DTAPURACAOSITUFREQ'])->format('d/m/Y'), $this->datasFaltas)){
                                   $this->datasFaltas[] = DateUtil::getDataDeString($faltaFreq['DTAPURACAOSITUFREQ'])->format('d/m/Y'); 
                                }
                            }
                            
                            $qtdeFaltas = $this->calculaFaltasFrequencia($arrayFaltasFreq);
                        }
                        
                        return $qtdeFaltas;
                        break;
                }
            } else {
                return $qtdeFaltas;
            }
            
        } else {
            $dtmescomp_falta = clone $this->dtiniperiodocalculo;
            $dtmescomp_falta = DateUtil::truncateData(DateUtil::getPrimeiroDiaDoMes($dtmescomp_falta));
            //Para a organização 1193-Russel ou 1024-Básica, para as faltas, são considerados dois meses anteriores à competencia atual*/
            if ($this->nrorg == 1193 || $this->nrorg == 1024) {
                $dtmescomp_falta = $dtmescomp_falta->sub(new \DateInterval('P1M'));
            }
            $qtdeFaltas = $this->calculaQtdeDiasFaltas($this->objvinculo->getNrvinculom(), $this->nrorg, $dtmescomp_falta, $dtmescomp_falta, $nreventom, $nrtpmovimento, $dtmescomp_falta);
            return $qtdeFaltas;
        }
        return $qtdeFaltas;
    }
    
    private function calculaQtdeDiasFaltas($objVinc, $nrorg, $dtIni, $dtFim, $nreventom, $nrtpmovimento, $dtmescompetencia){
        $faltas = FpaCalculofolha::getSomaItemCalculo($objVinc, $nrorg, $dtIni, $dtFim, $nreventom, $nrtpmovimento, $dtmescompetencia);
        $qtdeFaltas = (int)$faltas['VALOR'];
        
        return $qtdeFaltas;
    }

    /**
     * NÚMERO DE DIAS DE FÉRIAS
     * Considera-se dias que o vínculo ficou afastado por causa de férias.
     */
    private function setNrDiasFerias(\DateTime $dtinicio, \DateTime $dtfinal)
    {
        $diasFerias = 0;
        $dataInicio = clone($dtinicio);
        $dataFinal = clone($dtfinal);
        
        if(!empty($this->paramVale)){
            if($this->paramVale['IDCONSFERIASVALE'] == 'S'){
                $dataInicio = $dataInicio->sub(new \DateInterval('P' . $this->paramVale['QTMESESFERIASVALE'] . 'M'));
                $dataFinal = $dataFinal->sub(new \DateInterval('P' . $this->paramVale['QTMESESFERIASVALE'] . 'M'));
            } else {
                return $diasFerias;
            }
        }
        $diasFerias = $this->calculaQtdeDiasFerias($dataInicio, $dataFinal);
        return $diasFerias;
    }
    
    private function calculaQtdeDiasFerias($dtInicio, $dtFim){
        $ferias = FpaFerias::getPeriodoGozoFerias($this->objvinculo->getNrvinculom(), $dtInicio, $dtFim, $this->nrorg);
        $diasFerias = 0;
        
        if ($ferias) {
            $inicio = DateUtil::retornaMaiorData(substr($ferias['DTINIGOZOFERIAS'], 0, 10),$dtInicio->format('d/m/Y'));
            $final  = DateUtil::retornaMenorData(substr($ferias['DTFIMGOZOFERIAS'], 0, 10),$dtFim->format('d/m/Y'));
            
            //Adiciona as datas entre o inicio e fim das ferias para o vinculo para ser utilizado na rotina de calculo de vt por dia de semana
            $this->datasEntreFerias = DateUtil::getDatasEntre(DateUtil::getDataDeString($inicio), DateUtil::getDataDeString($final));
            $this->dsrEntreFerias = $this->seekFeriado(DateUtil::getDataDeString($inicio), DateUtil::getDataDeString($final));
		    $this->feriadoEntreFerias = $this->seekDsr(DateUtil::getDataDeString($inicio), DateUtil::getDataDeString($final), $this->dsdiadescansosemanal);
		    
		    //Filtra o array de ferias para deixar de conter os dias de dsr e os de feriados dentro do periodo de ferias
            $this->datasEntreFerias = array_filter($this->datasEntreFerias, function ($element) {
                $data = $element->format(DateUtil::FORMATO_DATA);
                
                if(!empty($this->feriadoEntreFerias) && !empty($this->dsrEntreFerias)){
                    return !in_array($data, $this->feriadoEntreFerias) && !in_array($data, $this->dsrEntreFerias);
                } else if(!empty($this->feriadoEntreFerias) && empty($this->dsrEntreFerias)) {
                    return !in_array($data, $this->feriadoEntreFerias);
                } else {
                    return !in_array($data, $this->dsrEntreFerias);
                }
            });
            
            $totalFerias = DateUtil::getDataDeString($inicio)->diff(DateUtil::getDataDeString($final));
            
        	$arFeriados  = $this->seekFeriado(DateUtil::getDataDeString($inicio)->format('d/m/Y'), DateUtil::getDataDeString($final)->format('d/m/Y'));
            $feriados    = count($arFeriados);
    
            if( isset($this->nrturno) ){
                $arrayDiasFolgaVinc = $this->calcularQtdeDiasFolgaVinc(DateUtil::getDataDeString($inicio), $totalFerias, $this->objvinculo->getNrvinculom(), $this->nrturno);
                $intersecao = count(array_intersect($arrayDiasFolgaVinc, $arFeriados)); //quantidade de dias que coincidem Folga e Feriados
                $diasFerias = ($totalFerias->d+1) - count($arrayDiasFolgaVinc) - $feriados + $intersecao;

                MemoriaVT::getInstance()->detalharFerias(
                    array(
                        'tipo' => 'turno', 
                        "formula" => "resultado = totalFerias - diasFolgaVinc - feriados + intersecaoFolgaFeriado",
                        "expressao" => $diasFerias.' = '.($totalFerias->d+1).' - '.count($arrayDiasFolgaVinc).' - '.$feriados.' + '.$intersecao,
                        "resultado" => $diasFerias,
                        "totalFerias" => ($totalFerias->d+1),
                        "diasFolgaVinc" => count($arrayDiasFolgaVinc),
                        "feriados" => $feriados,
                        "intersecaoFolgaFeriado" => $intersecao,
                    )
                );
            }else{
                $descRemunerado = $this->seekDsr($inicio, $final);
                //return (((int)$ferias['QUANTIDADE']) - count($descRemunerado));
                $intersecao = count(array_intersect($descRemunerado, $arFeriados)); //quantidade de dias que coincidem DSR e Feriados
                $diasFerias = ($totalFerias->d+1) - count($descRemunerado) - $feriados + $intersecao;


                MemoriaVT::getInstance()->detalharFerias(
                    array(
                        'tipo' => 'dsr', 
                        "formula" => "resultado = totalFerias - dsr - feriados + intersecaoDsrFeriado",
                        "expressao" => $diasFerias.' = '.($totalFerias->d+1).' - '.count($descRemunerado).' - '.$feriados.' + '.$intersecao,
                        "resultado" => $diasFerias,
                        "totalFerias" => ($totalFerias->d+1),
                        "dsr" => count($descRemunerado),
                        "feriados" => $feriados,
                        "intersecaoDsrFeriado" => $intersecao,
                    )
                );
            }
        }

        return $diasFerias;
    }

    /**
     * NÚMERO DE DIAS DE AVISO
     * Considera-se dias que o vínculo ficou trabalhando cumprindo aviso prévio.
     */
    private function setNrDiasAviso(\DateTime $dtinicio, \DateTime $dtfinal)
    {
        $diasAviso = null;

        if ($this->objvinculo->getDtrescisaovinc()) {

            $dtrescisao = $this->objvinculo->getDtrescisaovinc();
            
            if( !($this->objvinculo->getDtrescisaovinc() instanceof \DateTime) )
                $dtrescisao = DateUtil::getDataDeString($dtrescisao, DateUtil::FORMATO_BRASILEIRO, true);
        
            $iniperiodo = $dtinicio;
            $fimperiodo = $dtfinal;

            if ( $this->objvinculo->getDtavisoprevio() and \HCM\Util\DateUtil::isBetween($dtrescisao->format('d/m/Y'), $iniperiodo->format('d/m/Y'), $fimperiodo->format('d/m/Y')) ) {
                $nrdiasaviso = DateUtil::getQtdeDiasEntre($iniperiodo, $dtrescisao) + 1;
                
                $nrdsr = $this->seekDsr($iniperiodo->format('d/m/Y'), $dtrescisao->format('d/m/Y'));
                $arFeriados = $this->seekFeriado($iniperiodo->format('d/m/Y'), $dtrescisao->format('d/m/Y'));
                $intersecaoDsrFeriado = count(array_intersect($nrdsr, $arFeriados)); //quantidade de dias que coincidem Dsr e Feriados
                
                $diasAviso = $nrdiasaviso - count($nrdsr) - count($arFeriados) - $intersecaoDsrFeriado;
            }
            
            if($dtrescisao < $iniperiodo){
                $this->datasAposRescisao = DateUtil::getDatasEntre(DateUtil::getDataDeString($iniperiodo), DateUtil::getDataDeString($fimperiodo));
            } else if($dtrescisao >= $iniperiodo && $dtrescisao <= $fimperiodo) {
                $this->datasAposRescisao = DateUtil::getDatasEntre(DateUtil::getDataDeString($dtrescisao), DateUtil::getDataDeString($fimperiodo));
            }

        }
        
        return $diasAviso;
    }
    
    /**
     * Adiciona datas desconsideradas na rotina de vale por dia de semana
     * 
     */
    private function adicionaDataDesconsideradaParaS($datas, $idDiaSemana){
        foreach($datas as $data){
            $data = DateUtil::truncateData(DateUtil::getDataDeString($data));

            if(in_array($data, $this->datasDesconsideradas)){
                continue;
            }
            
            //Se for S sai da iteraçao
            $idDiaSemanaAtual = substr($idDiaSemana, (DateUtil::getDiaSemana($data) - 1), 1);
            if($idDiaSemanaAtual == 'N'){
                continue;
            }
            
            array_push($this->datasDesconsideradas, $data);
        }
    }
    
    private function adicionaDataDesconsideradaParaN($datas, $idDiaSemana){
        foreach($datas as $data){
            if(in_array($data, $this->datasDesconsideradas)){
                continue;
            }
            
            //Se for N sai da iteraçao
            $idDiaSemanaAtual = substr($idDiaSemana, (DateUtil::getDiaSemana($data) - 1), 1);
            if($idDiaSemanaAtual == 'S'){
                continue;
            }

            array_push($this->datasDesconsideradas, $data);
        }
    }

    //INFORMAÇÕES SOBRE A LINHA
    /**
     * QUANTIDADE DE PASSAGENS NECESSÁRIAS PARA CADA LINHA DE TRANSPORTE
     */
    private function setPassagens()
    {
        //IMPLEMENTAÇOES DO NOVO MODULO DE VALE
            //Feriados dentro do periodo
            $arrFeriados = $this->seekFeriado($this->dtiniperiodovale, $this->dtfimperiodovale);
            
            //Dsrs dentro do periodo
            $periodoInicial = clone $this->dtiniperiodovale;
            $periodoFinal = clone $this->dtfimperiodovale;
            
            $arrDsr = $this->seekDsr($periodoInicial, $periodoFinal, $this->dsdiadescansosemanal);
            
            //Filtra o array de atestado/afastamento para deixar de conter os dias de dsr e os de feriados dentro do periodo do afastamento/atestado
            $this->datasEntreAtestadoOuAfast = array_filter($this->datasEntreAtestadoOuAfast, function ($element) {
                $data = $element->format(DateUtil::FORMATO_DATA);
                
                return !in_array($data, $this->datasDsrAnt) && !in_array($data, $this->datasFeriadosAnt);
            });
            
            //Se o campo dias apurados estiver preenchido da um merge nos arrays desconsiderando feriados e DSR's, ja que o dia util e fixado.
            if(!empty($this->qtdiasvalefixo)){
                //Merge nos arrays que vem das rotinas do calculo
                $arrDatasDesconsideradasRotinas = array_merge(
                    $this->datasFaltas,                 $this->datasEntreAtestadoOuAfast,   $this->datasAposRescisao,     $this->datasEntreFerias
                );
            } else {
                //Merge nos arrays que vem das rotinas do calculo
                $arrDatasDesconsideradasRotinas = array_merge(
                    $this->datasFaltas,                 $this->datasEntreAtestadoOuAfast,   $this->datasAposRescisao,     $this->datasEntreFerias,   
                    $arrFeriados,                       $arrDsr
                );
            }
            
        //
        
        $linhasvinculo = $this->getPassagensNecessarias( $this->dtiniperiodovale, $this->dtfimperiodovale, $this->nrtipolinhavinc);
        if($linhasvinculo){
            $tarifa = array();
            
            foreach ($linhasvinculo as $linhavinculo) {
                $difference = 0;

                //Formula nova para vales especificos para dias de semana
                //Verifica se a string tem S(ou seja se esta marcado)
                if(strpos($linhavinculo['IDDIASSEMANA'], 'S') !== false){

                    //Itera dentro das datas desconsideradas do $arrMestre verificando se o dia esta marcado como S, se estiver ele deve desconsidera-lo.
                    $this->adicionaDataDesconsideradaParaS($arrDatasDesconsideradasRotinas, $linhavinculo['IDDIASSEMANA']);
                    
                    //Se o campo Dias apurados estiver preenchido não olha para as datas entre o inicio e fim do vale...
                    if(empty($this->qtdiasvalefixo)){
                        //Itera dentro das datas entre o inicio do periodo e o fim, passando pelos IDDIASSEMANA, verificando se os dias ja foram desconsiderados.
                        $this->adicionaDataDesconsideradaParaN($this->datasEntre, $linhavinculo['IDDIASSEMANA']);
                    }
                    
                    if($this->idcalccomplementar == 'S'){
                        //Se o idcalccomplementar for 'S' ele devera não descontar as datas desconsideradas.
                        $difference = $this->qtdiasvalefixo;
                    } else {
                        //calcula a quantidade de dias necessarios de vales
                        $difference = ((empty($this->qtdiasvalefixo) ? count($this->datasEntre) : $this->qtdiasvalefixo) - count($this->datasDesconsideradas));
                    }
                    
                    if($difference < 0){
                        $difference = 0;
                    }
                    
                    $tarifa[] = array(  'NRLINHATRANSP' => $linhavinculo['NRLINHATRANSP'],
                                    'NRTARIFA' => $linhavinculo['NRTARIFA'],
                                    'NRVINCULOM' => $linhavinculo['NRVINCULOM'],
                                    'NRSENTIDOLINHA' => $linhavinculo['NRSENTIDOLINHA'],
                                    'NRTIPOLINHAVINC' => $linhavinculo['NRTIPOLINHAVINC'],
                                    'QTLINHATARIFA' => $linhavinculo['QTLINHATARIFA'],
                                    'IDDIASSEMANA' => $linhavinculo['IDDIASSEMANA'],
                                    //NEW
                                    'TPCALCVALE' => empty($this->qtdiasvalefixo) ? 'Dia P/ Semana' : 'Vale com dias úteis fixo pelo campo Dias Apurados',
                                    'DIASDESCONTADOS' => count($this->datasDesconsideradas),
                                    //END
                                    'VRTARIFA' => $linhavinculo['VRTARIFA'],
                                    'VALOR' => $linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $difference,
                                    'DIAS'  => $difference,
                                    'NRTURNO' => $this->nrturno,
                                );

                    $this->vrtotal += $linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $difference;
                } else {
                    $tarifa[] = array(  'NRLINHATRANSP' => $linhavinculo['NRLINHATRANSP'],
                                    'NRTARIFA' => $linhavinculo['NRTARIFA'],
                                    'NRVINCULOM' => $linhavinculo['NRVINCULOM'],
                                    'NRSENTIDOLINHA' => $linhavinculo['NRSENTIDOLINHA'],
                                    'NRTIPOLINHAVINC' => $linhavinculo['NRTIPOLINHAVINC'],
                                    'QTLINHATARIFA' => $linhavinculo['QTLINHATARIFA'],
                                    'IDDIASSEMANA' => $linhavinculo['IDDIASSEMANA'],
                                    'TPCALCVALE' => empty($this->qtdiasvalefixo) ? 'Mensal' : 'Vale com dias úteis pelo fixo campo Dias Apurados',
                                    'DIASDESCONTADOS' => null,
                                    'VRTARIFA' => $linhavinculo['VRTARIFA'],
                                    'VALOR' => $linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $this->diastotaisconsideracao,
                                    'DIAS'  => $this->diastotaisconsideracao,
                                    'NRTURNO' => $this->nrturno,
                                );
                                
                    $this->vrtotal += $linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $this->diastotaisconsideracao;
                }
                $this->datasDesconsideradas = [];
            }
        }else{
            $this->messages[] = "Vínculo: ".$this->objvinculo->getNmvinculom()." não possui linha de vale transporte cadastrada!";
            
            $erro['STATUS'] = false;
            $erro['MOTIVO'] = "Vínculo não possui linha de vale transporte cadastrada!";
            MemoriaVT::getInstance()->setImpeditivosParaGerarVale($erro);
            
            $tarifa = 0;
            $this->vrtotal = 0;
        }
        
        $this->passagens = $tarifa;
    }

    //INFORMAÇÕES SOBRE O MÊS
    /**
     * COMPOSIÇÃO DO PRÓXIMO MÊS
     * considera-se quantos dias úteis haverão no próximo dia útil.
     *
     * @param \DateTime $dtiniciovale
     * @param \DateTime $dtfinalvale
     *
     * @return int
     *
     */
    private function setNrDiasCalculo(\DateTime $dtiniciovale, \DateTime $dtfinalvale, $dadosVinc = null)
    {
        $dtinicio = $dtfinal = $dias = $nrTurno = $nrVinculom = $qtdeDiasTrabalhados = $total = null;
        
        // $competencia = DateUtil::getDataDeString($this->dtmescompetencia);
        // $competencia = $competencia->add(new \DateInterval('P1M'));
        
        $dtinicio = clone $dtiniciovale;
        $dtfinal = clone $dtfinalvale;

        if(!($dtinicio instanceof \DateTime)) $dtinicio = DateUtil::getDataDeString($dtinicio, DateUtil::FORMATO_BRASILEIRO, true);
        
        if(!($dtfinal instanceof \DateTime)) $dtfinal = DateUtil::getDataDeString($dtfinal, DateUtil::FORMATO_BRASILEIRO, true);
        
        $dias = $dtinicio->diff($dtfinal, true);
        
        if(isset($dadosVinc)){ // $dadosVinc é o parâmetro passado na chamada dentro de getValorRestante
            $nrTurno = $dadosVinc['NRTURNO'];
            $nrVinculom  = $dadosVinc['NRVINCULOM'];
        }else{
            $nrTurno = $this->nrturno;
            $nrVinculom  = $this->objvinculo->getNrvinculom();
        }

    	$arFeriados = $this->seekFeriado($dtinicio->format('d/m/Y'), $dtfinal->format('d/m/Y'));
        $feriados        = count($arFeriados);
        
        if( isset($nrTurno) ){
            /*$qtdeDiasTrabalhados = GpeEscalatrabm::retornaQtdeDiasTrabalhoPorVinc( // dias totais do período menos dias de folga. Feriados são considerados como dias trabalhados
                $this->dtmescompetencia, 
                $dtinicio->format('d/m/Y'), 
                $dias->d, 
                $this->nrorg, 
                $nrVinculom
            );*/
            $qtdeDiasTrabalhados = GpeEscalatrabm::retornaQtdeDiasTrabalhoPorTurno( // dias totais do período menos dias de folga. Feriados são considerados como dias trabalhados
                $this->dtmescompetencia, 
                $dtinicio->format('d/m/Y'), 
                $dias->d, 
                $this->nrorg, 
                $nrTurno
            );
            
            if($qtdeDiasTrabalhados == 0){
                $this->messages[] = "Vínculo: ".$this->objvinculo->getNmvinculom()." possui escala com turno cadastrado mas o turno não possui horários, impossibilitando o cálculo da quantidade de dias trabalhados do vínculo!";
                
                $erro['STATUS'] = false;
                $erro['MOTIVO'] = "Vínculo possui escala com turno cadastrado mas o turno não possui horários, impossibilitando o cálculo da quantidade de dias trabalhados do vínculo!";
                MemoriaVT::getInstance()->setImpeditivosParaGerarVale($erro);
            }
        
            $arrayDiasFolgaVinc = $this->calcularQtdeDiasFolgaVinc($dtiniciovale, $dias, $nrVinculom, $nrTurno);
            $diasFolga = count($arrayDiasFolgaVinc);
            $intersecaoFolgaFeriado = count(array_intersect($arrayDiasFolgaVinc, $arFeriados)); //quantidade de dias que coincidem Folga e Feriados
            
            // Verifica se o turno possui algum horário do tipo TURNO, para entender que a escala é 12x36 e desconsiderar os feriados
            $params = array(
                'P_NRORG' => $this->nrorg,
                'P_NRTURNO' => $nrTurno,
                'P_DTMESCOMPETENC' => $dtinicio->format('d/m/Y'),
            );
            $where = "NRORG = :P_NRORG AND NRTURNO = :P_NRTURNO AND EXISTS (SELECT 1 FROM GPE_HORDIAH HH
                                                                            WHERE HH.NRHORDIAM = e.NRHORDIAM
                                                                              AND HH.NRORG = e.NRORG
                                                                              AND HH.IDTIPOHORARIO = 'T'
                                                                              AND HH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_HORDIAH
                                                                                                            WHERE GPE_HORDIAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                                                              AND GPE_HORDIAH.NRHORDIAM = HH.NRHORDIAM
                                                                                                              AND GPE_HORDIAH.NRORG = HH.NRORG))";
            $gpeHorarioturno = GpeHorarioturno::getObjectByWhere($where,$params);
            if ($gpeHorarioturno) {
                // Zera feriados se tiver horário do tipo TURNO
                $feriados = 0;
                $intersecaoFolgaFeriado = 0;
            }
            
            $total = $qtdeDiasTrabalhados - ($feriados - $intersecaoFolgaFeriado); // subtrair apenas feriados que não sejam em dias de folga
            
            if(!isset($dadosVinc)){
                MemoriaVT::getInstance()->detalharDiasConsPeriodo(
                    array(
                        'tipo' => 'turno', 
                        "formula" => "resultado = qtdeDiasTrabalhados - (feriados - intersecaoFolgaFeriado)",
                        "expressao" => $total.' = '.$qtdeDiasTrabalhados.' - ('.$feriados.' - '.$intersecaoFolgaFeriado.')',
                        "resultado" => $total,
                        "qtdeDiasTrabalhados" => $qtdeDiasTrabalhados,
                        "feriados" => $feriados,
                        "intersecaoFolgaFeriado" => $intersecaoFolgaFeriado,
                    )
                );
            }

        }else{
            $dias->d++;
    		$arDsr      = $this->seekDsr($dtinicio->format('d/m/Y'), $dtfinal->format('d/m/Y'), $this->dsdiadescansosemanal);
            //quantidade de dias que coincidem DSR e Feriados
            $intersecao = count(array_intersect($arDsr, $arFeriados));
            $descansosemanal = count($arDsr);
            $total = $dias->d - $descansosemanal - $feriados + $intersecao;
            
            if(!isset($dadosVinc)){
                MemoriaVT::getInstance()->detalharDiasConsPeriodo(
                    array(
                        'tipo' => 'dsr', 
                        "formula" => "resultado = diasPeriodo - dsr - feriados + intercecaoDsrFeriado",
                        "expressao" => $total.' = '.$dias->d.' - '.$descansosemanal.' - '.$feriados.' + '.$intersecao,
                        "resultado" => $total,
                        "diasPeriodo" => $dias->d,
                        "dsr" => $descansosemanal,
                        "feriados" => $feriados,
                        "intersecaoDsrFeriado" => $intersecao,
                    )
                );
            }
            
        }

        return $total;

    }

    //FUNÇÕES DE SUPORTE
    /**
     * VERIFICA DSR
     * Verifica os quantos dias de descanso remunerado houveram em um determinado período.
     * @param string $dtiniperiodoapur (Formato 'dd/mm/yyyy')
     * @param string $dtfimperiodoapur (Formato 'dd/mm/yyyy')
     * @return array
     */

    private function seekDsr($dtiniperiodoapur, $dtfimperiodoapur)
    {
        
        $dtiniperiodoapur = clone DateUtil::getDataDeString($dtiniperiodoapur);
        $dtfimperiodoapur = clone DateUtil::getDataDeString($dtfimperiodoapur);
        
        $diasDsr = array();

        switch($this->dsdiadescansosemanal){
            case (self::SABADO):{
                while($dtiniperiodoapur->format('N') != 6){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::DOMINGO):{
                while($dtiniperiodoapur->format('N') != 7){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::SABDOM):{
                while($dtiniperiodoapur->format('N') != 7 and $dtiniperiodoapur->format('N') != 6){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                if($dtiniperiodoapur->format('N') == 7){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P6D'));
                }
                while($dtiniperiodoapur<$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P6D'));
                }
                if(($dtfimperiodoapur->format('N') == 6 or $dtfimperiodoapur->format('N') == 7) and ($dtiniperiodoapur<=$dtfimperiodoapur)){
                    $diasDsr[] = $dtfimperiodoapur->format('d/m/Y');
                }
                break;
            }
            case (self::SEGUNDA):{
                while($dtiniperiodoapur->format('N') != 1){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::TERCA):{
                while($dtiniperiodoapur->format('N') != 1){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::QUARTA):{
                while($dtiniperiodoapur->format('N') != 3){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::QUINTA):{
                while($dtiniperiodoapur->format('N') != 4){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::SEXTA):{
                while($dtiniperiodoapur->format('N') != 5){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
        }
        return $diasDsr;
    }
    
    /**
     * RETORNA QUANTIDADE DE FOLGAS
     * Retorn a quantidade de folgas do vínculo a partir de um período informado
     * @param data $dtInic
     * @param int $dias
     * @param int $nrvinculom
     * @return array 
     */ 
    private function calcularQtdeDiasFolgaVinc($dtInic, $dias, $nrVinculo, $nrTurno=null){
        $array = [];
        
        if (is_null($nrTurno)) {
            $diasDeFolgaNoPeriodo = GpeEscalatrabm::retornaDiasFolgaVinc(
                $this->hcmParameters->getDtCompetencia(), 
                $dtInic->format('d/m/Y'), 
                $dias->d, 
                $this->hcmParameters->getNrorgTrabalho(), 
                $nrVinculo
            );
        } else {
            $diasDeFolgaNoPeriodo = GpeEscalatrabm::retornaDiasFolgaTurno(
                $this->hcmParameters->getDtCompetencia(), 
                $dtInic->format('d/m/Y'), 
                $dias->d, 
                $this->hcmParameters->getNrorgTrabalho(), 
                $nrTurno
            );
        }

        foreach($diasDeFolgaNoPeriodo as $value) $array[] = $value['DTDATA'];

        return $array;
    }
 
    /**
     * BUSCAR FERIADOS
     * Verifica quantos feriados existem em um período de datas passadas por parâmetros.
     * @param string $dtiniperiodoapur
     * @param string $dtfimperiodoapur
     * @return int
     */
    private function seekFeriado($dtiniperiodoapur, $dtfimperiodoapur)
    {
        $result = array();
        
        if( $this->nrestrutlegal == null ){
            $instancia = MsgCalculo::getInstance();
            $instancia->setDados($this->hcmParameters->determinaNrCalculoFolha(FpaTipomoviment::TP_MOV_VALE_TRANSPORTE), $this->objvinculo->getNrvinculom(), $this->hcmParameters->getNrorgTrabalho(), "CALCULOVT");
            
            MsgCalculo::getInstance()->adicionaMensagem('O vínculo '.$this->objvinculo->getNmvinculom().' não possui estrutura legal.', MsgCalculo::ALERTA);
            
            $instancia->salvaMensagens();
            $instancia->clear();
        } else {
            if($this->geraBenefFeriado == 'N'){
                
                $nrestrutlegal = $this->nrestrutlegal;
                    
                $paramOrg = FPA::getGpeParametrosOrganizacao();
            
                //Busca calendario da estrutra de movimentacao.
                if($paramOrg->getNrtpestrutcalend()){
                    
                    $movimentacoes = $this->_movimentosVinculo->carregaMovimentacoesPorTipoEstrutura($this->objvinculo->getNrorg(), $this->objvinculo->getNrvinculom(), $this->hcmParameters->getUltimoDiaMes(), $paramOrg->getNrtpestrutcalend());
                    
                    if($movimentacoes){
                        
                        foreach ($movimentacoes as $movimentacao){
                            $nrestrutlegal = $movimentacao->getNrestruturam();
                        }
                    }
                }
                
                $feriados = Estruturah::getFeriados($dtiniperiodoapur, $dtfimperiodoapur, $nrestrutlegal, $this->dtmescompetencia, $this->nrorg);
        		foreach($feriados as $feriado){
                    $result[] = substr($feriado['DTCALENDARIO'], 0, 10);
        		}
            }
        }
        return $result;
    }

    /**
     * BUSCAR OBJETO DE HISTÓRICO DO VÍNCULO ATUAL
     */
    private function setVinculoh()
    {
        $dtmescompetencia = $this->dtmescompetencia;

        try {
            $params = array(
                'P_NRORG' => $this->nrorg,
                'P_NRVINCULOM' => $this->objvinculo->getNrvinculom());
            $where = "NRORG = :P_NRORG AND NRVINCULOH = (SELECT NRVINCULOH FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND NRVINCULOM = :P_NRVINCULOM AND DTMESCOMPETENC = (SELECT MAX(MAX_VINCULOH.DTMESCOMPETENC) FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.DTMESCOMPETENC <= '$dtmescompetencia' AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG))";
            $historico = GpeVinculoh::getObjectByWhere($where, $params);

            if ($historico) {
                return $historico;
            } else {
                throw new \Exception('Vinculo '.$this->objvinculo->getNrvinculom().' - '.$this->objvinculo->getNmvinculom().' não possui histórico.', Messages::ERROR_MESSAGE_CODE);
            }
        }catch (\Exception $e){
            throw $e;
        }
    }

    /**
     * BUSCA A ESTRUTURA LEGAL DO VÍNCULO ATUAL
     */
    private function setNrestrutlegal()
    {
        return $this->objvinculoh->getNrestrutlegal();
    }

    public function getValeTransporte()
    {
        return $this->passagens;
    }

    public function getTotalTarifas()
    {
        return array('VALOR'      => $this->vrtotal,
                     'REFERENCIA' => $this->diastotaisconsideracao);
    }

    /**
     * Adiciona os vínculos de líquido no histórico para os mesmos
     * @param array $info
     * @param int $vinculo
     * @return void
     */
    public function addHistorico($info, $vinculo, $dtpagamento)
    {
        /**
         * @var VabHistvalevinc $hist
         */
        $dtiniapuravale = clone $this->dtiniperiodovale;
        $dtfimapuravale = clone $this->dtfimperiodovale;

        //$nrcalculo = tk_get_env_var('NRCALCULO_VAB');
        //if (is_null(tk_get_env_var('NRCALCULO_VAB'))) {
            $nrcalculo = $this->hcmParameters->determinaNrCalculoFolha(FpaTipomoviment::TP_MOV_VALE_TRANSPORTE);
        //}

        //Busca lançamentos de vale vínculo para aquela competência
        $params = array(
            'P_NRVINCULOM'        => $info['NRVINCULOM'],
            //'P_NRCALCULOFOLHA'    => tk_get_env_var('NRCALCULO_VAB'),
			'P_NRCALCULOFOLHA'    => $nrcalculo,
            'P_DTMESCOMPAPVALE'   => $this->dtmescompetencia,
            'P_NRLINHATRANSP'     => $info['NRLINHATRANSP'],
            'P_NRORG'             => $this->nrorg,
            'P_FORMINI'           => $dtiniapuravale->format('d/m/Y'),
            'P_FORMFIM'           => $dtfimapuravale->format('d/m/Y'),
            'DTPGTOVALE'          => $dtpagamento->format('d/m/Y'));
        $where = "NRORG = :P_NRORG 
                    AND NRVINCULOM = :P_NRVINCULOM 
                    AND NRCALCULOFOLHA = :P_NRCALCULOFOLHA 
                    AND TRUNC(DTMESCOMPAPVALE) = :P_DTMESCOMPAPVALE 
                    AND NRLINHATRANSP = :P_NRLINHATRANSP
                    AND DTPGTOVALE = :DTPGTOVALE
                    AND DTINIAPURVALE <= :P_FORMFIM 
                    AND DTFINAPURVALE >= :P_FORMINI";
        $obj = \Folha\Entities\VabHistvalevinc::getObjectByWhere($where, $params);

        $valorCartao = $this->getValorRestante($vinculo, $info);

        if (!$obj and $info['DIAS'] > 0) {
            $info['STATUS'] = true;
            $info['MOTIVO'] = "SUCESSO";
            MemoriaVT::getInstance()->setInfoValesVinc($info);

            $hist = new VabHistvalevinc();
            $hist->setNrhistvalevinc(NovoCodigo::geraCodigo($this->nrorg, 'VAB_HISTVALEVINC' . $this->nrorg, 1, 22, true));
            $hist->setNrlinhatransp($info['NRLINHATRANSP']);
            $hist->setNrvinculom($vinculo);
            $hist->setNrtarifa($info['NRTARIFA']);
            $hist->setNrvinculom($info['NRVINCULOM']);
            $hist->setNrsentidolinha($info['NRSENTIDOLINHA']);
            $hist->setNrtipolinhavinc($info['NRTIPOLINHAVINC']);
            //$hist->setNrcalculofolha(tk_get_env_var('NRCALCULO_VAB'));
            $hist->setNrcalculofolha($nrcalculo);
            $hist->setNrorg($this->hcmParameters->getNrorgTrabalho());
            $hist->setDtmescompapvale(DateUtil::getDataDeString($this->dtmescompetencia, DateUtil::FORMATO_BRASILEIRO, true));
            $hist->setDtiniapurvale($dtiniapuravale);
            $hist->setDtfinapurvale($dtfimapuravale);
            $hist->setQtapurvale($info['QTLINHATARIFA']);
            $hist->setIdativo('S');
            $hist->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
            $hist->setDtinclusao(DateUtil::getDataAtual());
            $hist->setCdoperinclusao($this->hcmParameters->getCdoperador());
            $hist->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
            $hist->setDtultatu(DateUtil::getDataAtual());
            $hist->setCdoperultatu($this->hcmParameters->getCdoperador());
            $hist->setQtdiasvale($info['DIAS']);
            $hist->setVrdeducaovale($valorCartao);
            $hist->setDtpgtovale($dtpagamento);
            $hist->setIdajustemanual('N');

            $hist->persist();
        }elseif( $obj && $info['DIAS'] > 0){
            $info['STATUS'] = false;
            $info['MOTIVO'] = "Lançamento já Calculado";
            MemoriaVT::getInstance()->setInfoValesVinc($info);
        }elseif( $obj && $info['DIAS'] <= 0){
            $info['STATUS'] = false;
            $info['MOTIVO'] = "Lançamento já calculado e sem dias de consideração";
            MemoriaVT::getInstance()->setInfoValesVinc($info);
        }

    }

    /**
    * Busca valor do restante no cartão cartão
    * @param int $nrvinculom
    * @return float
    */
    private function getValorRestante($nrvinculom, $info)
    {
        /**
         * Busca valor do cartão
         * @var VabIntegtransph $cartao
         */
        $params = array(
            'P_NRORG' => $this->nrorg,
            'P_NRVINCULOM' => $nrvinculom,
            'P_DTMESCOMPETENCIA' => $this->dtmescompetencia,
            'P_NRTIPOLINHAVINC' => $info['NRTIPOLINHAVINC'],
            'P_DTINILINHAVINC' => $this->dtiniperiodovale->format('d/m/Y'),
            'P_DTFIMLINHAVINC' => $this->dtfimperiodovale->format('d/m/Y'),
        );
        $orderBy = "DTMESCOMPINTEG DESC";
        $where = "NRORG = :P_NRORG AND NRTIPOLINHAVINC = :P_NRTIPOLINHAVINC AND NRINTEGTRANSPH IN ( SELECT VAB_INTEGTRANSPH.NRINTEGTRANSPH FROM VAB_INTEGTRANSPH LEFT JOIN VAB_LINHAVINC ON VAB_LINHAVINC.NRORG = VAB_INTEGTRANSPH.NRORG AND VAB_LINHAVINC.NRINTEGTRANSPM = VAB_INTEGTRANSPH.NRINTEGTRANSPM WHERE VAB_INTEGTRANSPH.NRORG = :P_NRORG AND VAB_LINHAVINC.NRVINCULOM = :P_NRVINCULOM AND VAB_LINHAVINC.NRTIPOLINHAVINC = VAB_INTEGTRANSPH.NRTIPOLINHAVINC AND ( VAB_LINHAVINC.DTINILINHAVINC <= :P_DTINILINHAVINC ) AND ( VAB_LINHAVINC.DTFIMLINHAVINC >= :P_DTFIMLINHAVINC OR VAB_LINHAVINC.DTFIMLINHAVINC IS NULL ) AND VAB_INTEGTRANSPH.DTMESCOMPINTEG = ( SELECT MAX(MAX_INTEGTRANSPH.DTMESCOMPINTEG) FROM VAB_INTEGTRANSPH MAX_INTEGTRANSPH WHERE VAB_INTEGTRANSPH.NRORG = MAX_INTEGTRANSPH.NRORG AND VAB_INTEGTRANSPH.NRINTEGTRANSPM = MAX_INTEGTRANSPH.NRINTEGTRANSPM AND MAX_INTEGTRANSPH.DTMESCOMPINTEG <= :P_DTMESCOMPETENCIA ) )";
        $cartao = VabIntegtransph::getObjectByWhere($where, $params, $orderBy);

        if($cartao instanceof VabIntegtransph){

            $dthoje = DateUtil::getDataAtual(true);
            // $dthoje = DateUtil::getDataDeString('17/09/2018', DateUtil::FORMATO_BRASILEIRO, true);
            $dtfinal = clone $this->dtiniperiodovale;
            $dtfinal->sub(new \DateInterval('P1D'));
            $diasRestantes = $this->setNrDiasCalculo($dthoje, $dtfinal, $info);
            $passagensNecessaria = $this->getPassagensNecessarias($dtfinal, $dtfinal);

            $vrNecessario = 0;
            foreach ($passagensNecessaria as $passagemNecessaria) {
                if ($passagemNecessaria['NRTIPOLINHAVINC'] == $cartao->getNrtipolinhavinc()) {
                    $vrNecessario += $passagemNecessaria['VRTARIFA'] * $passagemNecessaria['QTLINHATARIFA'] * $diasRestantes;
                }
            }
            $valorCartao = $cartao->getVrsaldoultconsulta() - $vrNecessario;
        }else{
            $valorCartao = 0;
        }
        return $valorCartao > 0 ? $valorCartao : 0.00;
    }

    /**
     * @return array|bool
     */
    private function getPassagensNecessarias(\DateTime $dtinicio, \DateTime $dtfinal, $nrtipolinhavinc = null)
    {
        return VabLinhavinc::infoLinhaVinculoTarifa($this->objvinculo->getNrvinculom(), $this->nrorg, $dtinicio, $dtfinal, $nrtipolinhavinc, $this->hcmParameters->getNrorgPadrao());
    }
}