import {
  Http, IEventParam, Metadata, IDictionary,
} from '@zeedhi/core';
import {
  AlertService, Form, IGridEvent, Modal, ModalService, StateType, LoadingService,
} from '@zeedhi/common';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class Dfs48000SaidaDoOperadorLogisticoController {
  private gerarDocumentoModal!: Modal;
  
  private errosSaidaModal!: Modal;

  public readOnlySubGrup: StateType = true;

  public readOnlyRota: StateType = true;

  public readOnlyDestPed: StateType = true;

  public readOnlyLote: StateType = true;

  public filterValueCDFILIOPELOG: any = {};

  public filterValueCDROTATRANS: Array<any> = [];

  public filterValueCDSUBGRPPROD: Array<any> = [];

  public filterValueCDFILIALDEST: Array<any> = [];

  public filterValueCDLOTENVIOL: Array<any> = [];

  public filterValuePEDOLEXTR: Array<any> = [];

  public filterValueVERIFICACNPJ: any = null;

  public filterValueDTENTREGA: any = {};

  public filterValueSTATUS: Array<any> = [];

  public filterValueDATAENT: any = 0;

  public filterGridFormulario: any = {};

  public filterGridFormularioProduto: any = {};

  public filterGridLancamentoGerado: any = {};

  public filterValueNRINSJUREMPR: any = {};

  public filterValueIDUTILCONSSOLIOL: any = {};

  public filterValueFILCLIE: any = {};

  public periodDisabled: StateType = true;

  public swtDisabled: StateType = false;

  public adqEmpresa: any = {};

  public filterGridForm: any = {};

  public filterValueCDTIPOOPER: any;
  
  public showTabOtherGrids = false;
  
  public isLoadingDefault = false;
  
  public orderDescription = '';
  
  public filterRowPrincipal: any = {};

  public async createGerarDocumentoModal() {
    this.gerarDocumentoModal = await ModalService.createFromJson('pages/dfs48000/dfs4800Saida_do_opl_gerar_documento', true);
    this.errosSaidaModal = await ModalService.createFromJson('pages/dfs48000/dfs48000_erros_documento', true);
  }

  public destroyGerarDocumentoModal() {
    this.gerarDocumentoModal?.destroy();
    this.errosSaidaModal?.destroy();
  }

  public onChangeSwitchRota({ component }: IEventParam<any>) {
    if (this.readOnlyRota) {
      this.filterValueCDROTATRANS = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-CDROTATRANSFILTER-0') {
          child.value = [];
        }
      });
    }
  }

  public onChangeSwitchSubGrup({ component }: IEventParam<any>) {
    if (this.readOnlySubGrup) {
      this.filterValueCDSUBGRPPROD = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-CDSUBGRPRODFILTER-0') {
          child.value = [];
        }
      });
    }
  }

  public onChangeSwitchDestPed({ component }: IEventParam<any>) {
    if (this.readOnlyDestPed) {
      this.filterValueCDFILIALDEST = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-DSFILIALFILTER-0') {
          child.value = 'T';
        }
      });
    }
  }

  public onChangeSwitchLote({ component }: IEventParam<any>) {
    if (this.readOnlyLote) {
      this.filterValueCDLOTENVIOL = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-CDLOTENVITOLFILTER-0') {
          child.value = [];
        }
      });
    }
  }

  public onChangeLote() {
    this.swtDisabled = true;
  }

  public onChangeFieldFilialOL({ component }: any) {
    this.filterValueCDFILIOPELOG = component.value;
    
    const fielddest = component.parent.childrenInstances.filter((field: any) => field.name.includes('DSFILIAL'))[0];
    
    fielddest.datasource.clearFilter();
    
    fielddest.datasource.addFilter('P_CDFILIOPELOG', component.value !== null ? component.value.CDFILIAL : null);
    
    fielddest.datasource.removeOrder('P_CDFILIOPELOG');
    
    fielddest.datasource.data = [];
    
    fielddest.datasource.get();
  }

  public onChangeFieldRotaOL({ component }: any) {
    this.filterValueCDROTATRANS = component.value;
  }

  public onChangeFieldSubgrupoOL({ component }: any) {
    this.filterValueCDSUBGRPPROD = component.value;
  }

  public onChangeFieldFilialDestOL({ component }: any) {
    this.filterValueCDFILIALDEST = component.value;
  }

  public onChangeFieldLoteOL({ component }: any) {
    this.filterValueCDLOTENVIOL = component.value;
  }

  public onChangeFieldStatusPedidoOL({ component }: any) {
    this.filterValuePEDOLEXTR = component.value;
  }

  public onChangeFieldDTEntOL({ component }: any) {
    this.filterValueDATAENT = component.value;
  }

  public onChangeFieldStatusPedOL({ component }: any) {
    this.filterValueSTATUS = component.value;
  }

  public onChangeFieldInscrDestOL({ component }: any) {
    this.filterValueVERIFICACNPJ = component.value;
  }

  public onChangeFieldDataEntOL({ component }: any) {
    this.filterValueDTENTREGA = component.value;
  }

  public onChangeFieldTipoOperOL({ component }: any) {
    const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
    const fieldSerie = form.getChildInstance<any>('CDSERIE');
    
    if (component.value !== null) {
      fieldSerie.datasource.filter.P_CDTIPOOPER = component.value.CDTIPOOPER;
      
      fieldSerie.readonly = false;
    } else {
      fieldSerie.datasource.filter.P_CDTIPOOPER = '';
      
      fieldSerie.readonly = true;
    }
    
    fieldSerie.datasource.get();
    
    this.filterValueCDTIPOOPER = component.value;
  }
  
  public onChangeTransportadora({ component }: any) {
    const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
    const fieldPlaca = form.getChildInstance<any>('NRPLACA');
    
    if (component.value !== null) {
      fieldPlaca.datasource.filter.P_NRINSJURTRAN = component.value.NRINSJURTRAN;
      fieldPlaca.datasource.filter.P_IDTPIJURTRAN = component.value.IDTPIJURTRAN;
      
      fieldPlaca.readonly = false;
    } else {
      fieldPlaca.datasource.filter.P_NRINSJURTRAN = '';
      fieldPlaca.datasource.filter.P_IDTPIJURTRAN = '';
      
      fieldPlaca.readonly = true;
    }
    
    fieldPlaca.value = null;
    
    fieldPlaca.datasource.get();
  }

  public onFilterSaidaOpen({ component }: any) {
    LoadingService.show('Carregando...');
    
    const filterButton = document.getElementById('gridSaidasOPL_filterButton');
    
    filterButton?.click();
    
    setTimeout(() => {
      const campoRota = component.getFilterInputs('ROTASWITCH')[0];
      const campoSubgrupo = component.getFilterInputs('SUBGRUPRODSWITCH')[0];
      const campoDestino = component.getFilterInputs('DESTPEDSWITCH')[0];
      const campoLote = component.getFilterInputs('LOTESWITCH')[0];
      const campoStatusPed = component.getFilterInputs('PEDOLEXTR')[0].getChildInstance('PEDOLEXTR');
      const campoStatus = component.getFilterInputs('STATUSFILTER')[0].getChildInstance('STATUSFILTER');
      const campoDataCons = component.getFilterInputs('DATAENT')[0];
      const campoCnpj = component.getFilterInputs('VERIFICACNPJ')[0];
      
      campoRota.value = true;
      campoSubgrupo.value = true;
      campoDestino.value = true;
      campoLote.value = true;
      campoStatusPed.value = [
        {
          id: 'S',
          value: 'Extra',
        },
        {
          id: 'N',
          value: 'Não Extra',
        },
      ];
      campoStatus.value = [
        {
          id: 0,
          value: 'Vazio (Sem NF de Saída/Sem retorno do OL)',
        },
        {
          value: 'Amarelo (Sem NF de Saída/Com retorno do OL)',
          id: 1,
        },
        {
          value: 'Verde (Com NF de Saída Gerada)',
          id: 2,
        },
      ];
      campoDataCons.setValue(
        {
          name: 'Data de Entrega',
          value: 0,
        },
      );
      campoCnpj.setValue(
        {
          name: 'Desconsidera',
          value: null,
        },
      );
      
      LoadingService.hide();
    }, 200);
  }

  public formater(array: Array<any>) {
    return array.length !== 0 ? String('_').concat(array.join('_').concat(String('_'))) : 'T';
  }

  public async getInfo(datasourcefilter: string) {
    return Http.get(datasourcefilter);
  }

  public async onFilterload() {
    const grid = Metadata.getInstance<any>('gridSaidasOPL');
    const arrayCDFILIDEST = typeof grid.datasource.dynamicFilter.DSFILIALFILTER !== 'undefined' ? grid.datasource.dynamicFilter.DSFILIALFILTER[0].value.map((f: any) => f.CDFILIAL) : [];
    const arrayCDSUBGRPPROD = typeof grid.datasource.dynamicFilter.CDSUBGRPRODFILTER !== 'undefined' ? grid.datasource.dynamicFilter.CDSUBGRPRODFILTER[0].value.map((f: any) => f.CDSUBGRPROD) : [];
    const arrayCDROTATRANS = typeof grid.datasource.dynamicFilter.CDROTATRANSFILTER !== 'undefined' ? grid.datasource.dynamicFilter.CDROTATRANSFILTER[0].value.map((f: any) => f.CDROTATRANS) : [];
    const arrayCDLOTENVIOL = typeof grid.datasource.dynamicFilter.CDLOTENVITOLFILTER !== 'undefined' ? grid.datasource.dynamicFilter.CDLOTENVITOLFILTER[0].value.map((f: any) => f.CDLOTENVITOL) : [];
    const arrayPEDOLEXTR = this.filterValuePEDOLEXTR.length === 2 ? 'T' : this.filterValuePEDOLEXTR.map((f: any) => f.id);
    const arraySTATUS = this.filterValueSTATUS.map((f: any) => f.id);
    const nrinsjDatasource = 'crudN/dfs48000adqEmpresa?in=CDFILIOPELOG&CDFILIOPELOG='.concat(this.filterValueCDFILIOPELOG.CDFILIAL);
    const clienteExtDatasource = 'crudN/dfs48000adqclienteExt?in=CDFILIOPELOG&CDFILIOPELOG='.concat(this.filterValueCDFILIOPELOG.CDFILIAL);
    const utilConsOLDatasource = 'crudN/dfs48000adqParaSupri?in=CDFILIOPELOG&CDFILIOPELOG='.concat(this.filterValueCDFILIOPELOG.CDFILIAL);

    this.filterValueNRINSJUREMPR = await this.getInfo(nrinsjDatasource);
    this.filterValueFILCLIE = await this.getInfo(clienteExtDatasource);
    this.filterValueIDUTILCONSSOLIOL = await this.getInfo(utilConsOLDatasource);

    const filterFilial = {
      P_CDLOTENVIOL: this.formater(arrayCDLOTENVIOL),
      P_PEDOLEXTR: arrayPEDOLEXTR === 'T' ? 'T' : this.formater(arrayPEDOLEXTR),
      P_NRSJUREMPR: this.filterValueNRINSJUREMPR.data.data[0].NRINSJUREMPR,
      P_DATAENT: this.filterValueDATAENT.value,
      P_DTENTREGA: this.filterValueDTENTREGA,
      P_FILOPELOG: grid.datasource.dynamicFilter.CDFILIOPELOG[0].value.CDFILIAL,
      P_CDFILIAL: this.formater(arrayCDFILIDEST),
      P_ROTA: arrayCDROTATRANS.length > 0 ? this.formater(arrayCDROTATRANS) : null,
      P_FILCLIE: this.filterValueFILCLIE.data.data[0].CDCLIENTEEXT !== '0' ? 'L' : 'C',
      P_SUBGRUPO: this.formater(arrayCDSUBGRPPROD),
      P_VERIFICACNPJ: this.filterValueVERIFICACNPJ.value,
      P_CDCLIENTE: this.formater(arrayCDFILIDEST) === 'T' ? 'T' : null,
      P_STATUS: this.formater(arraySTATUS),
      P_IDUTILCONSSOLIOL: this.filterValueIDUTILCONSSOLIOL.data.data[0].IDUTILCONSSOLIOL,
    };
    
    this.filterRowPrincipal = filterFilial;

    grid.datasource.filter = filterFilial;
    grid.datasource.get();
  }

  public async loadGridFormulario(params: any) {
    const gridFormulario = Metadata.getInstance<TekGrid>('gridFormulario');
    const filterGridFormulario = {
      P_CDFILLANC: params.row.CDFILLANC,
      P_FILOPELOG: this.filterValueCDFILIOPELOG.CDFILIAL,
      P_NRAUTOFORN: params.row.NRAUTOFORN,
      P_SUBGRUPO: 'T',
      P_DATAENT: this.filterValueDATAENT.value,
      P_DTENTREGA: this.filterValueDTENTREGA,
      P_DTPROC: null,
      P_PEDOLEXTR: 'T',
      P_CDLOTENVIOL: 'T',
      P_IDBAIXAOLSA: 'T',
      P_IDUTILCONSSOLIOL: this.filterValueIDUTILCONSSOLIOL.data.data[0].IDUTILCONSSOLIOL,
      P_FILDEST: params.row.CDFILIAL,
    };
    
    gridFormulario.datasource.filter = filterGridFormulario;
    gridFormulario.datasource.get();
  }

  public loadGridFormularioProduto({ component }: any) {
    component.datasource.route = 'crudN/dfs48000gridSaidaOplFormularioProduto';

    component.datasource.filter = this.filterGridFormularioProduto;
    component.datasource.get();
  }

  public loadGridLancamentoGerado(params: any) {
    const gridLancamento = Metadata.getInstance<TekGrid>('gridLancamento');
    const filterGridLancamentoGerado = {
      P_CDFILDEST: params.row.CDFILIAL,
      P_DTENTREGA: this.filterValueDTENTREGA,
      P_CDFILLANC: params.row.CDFILLANC,
      P_NRAUTOFORN: params.row.NRAUTOFORN,
      P_DATAENT: this.filterValueDATAENT.value,
      P_CDLOTENVIOL: 'T',
      P_SUBGRUPO: 'T',
    };

    gridLancamento.datasource.filter = filterGridLancamentoGerado;
    gridLancamento.datasource.get();
  }

  public onChangeCdfiliOl({ component }: IEventParam<any>) {
    const fieldValueDestino = component.parent.getElementById('CDFILIALDEST');

    fieldValueDestino.datasource.filter.P_CDFILIOPELOG = component.value.CDFILIAL;

    fieldValueDestino.datasource.get();
  }

  public abrirModalGerarDocumento() {
    const grid = Metadata.getInstance<IGridEvent>('gridSaidasOPL');
    const selectedRows = grid.selectedRows;
    
    LoadingService.show('Carregando...');
    
    if (selectedRows.length > 0) {
      this.gerarDocumentoModal.show();
      
      setTimeout(() => {
        const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
        const fieldTipoOper = form.getChildInstance<any>('CDTIPOOPER');
        const fieldTransprt = form.getChildInstance<any>('NMRAZSOCTRAN');
        const fieldSerie = form.getChildInstance<any>('CDSERIE');
        const fieldData = form.getChildInstance<any>('DATA');
        const unidades: any[] = [];
        
        selectedRows.forEach((row: any) => {
          unidades.push(row.CDFILIAL);
        });
        
        fieldTransprt.datasource.filter.P_CDFILIALOL = this.filterValueCDFILIOPELOG.CDFILIAL;
        
        fieldSerie.datasource.filter.P_CDFILIALOL = this.filterValueCDFILIOPELOG.CDFILIAL;
        
        const unStr = unidades.join('_');
        const unidadesString = String('_').concat(String(unStr).concat(String('_')));
        
        const row = {
          CDFILIOPELOG: this.filterValueCDFILIOPELOG.CDFILIAL,
          DTENTRSAID: this.filterValueDTENTREGA,
        };
        
        Http.get(`crudN/dfs48000_clienteext?in=P_CDFILIOPELOG&P_CDFILIOPELOG=${this.filterValueCDFILIOPELOG.CDFILIAL}`).then((response) => {
          Http.get(`crudN/dfs48000_tipooper_param?in=P_CDFILIOPELOG&in=P_CDFILIAL&P_CDFILIOPELOG=${this.filterValueCDFILIOPELOG.CDFILIAL}&P_CDFILIAL=${unidadesString}`).then((response1) => {
            Http.post('getDtProcessaOpl', { requestType: 'Row', row }).then((response2) => {
              if (response2.data.dataset.res[0].MESSAGE === null) {
                fieldData.value = this.filterValueDTENTREGA;
              } else {
                fieldData.value = response2.data.dataset.res[1].DTPROCESSA;
              }
              
              if (response1.data.data.length > 0) {
                fieldTipoOper.setValue(response1.data.data[0].CDTIPOOPERSAID);
                
                fieldTipoOper.readonly = true;
                
                fieldTipoOper.datasource.get().then(() => {
                  LoadingService.hide();
                });
              } else {
                if (response.data.data.length > 0) {
                  let cont = 0;
                  
                  response.data.data.forEach((r: any) => {
                    if (r.CDCLIENTEEXT !== null) {
                      cont += 1;
                    }
                  });
                  
                  if (cont === 0) {
                    fieldTipoOper.datasource.filter.P_CDTIPOOPER = '02';
                    fieldTipoOper.datasource.filter.P_IDORIGDESTOP = 'L';
                    
                    fieldTipoOper.datasource.get().then(() => {
                      LoadingService.hide();
                    });
                  } else {
                    fieldTipoOper.datasource.filter.P_CDTIPOOPER = '';
                    fieldTipoOper.datasource.filter.P_IDORIGDESTOP = 'C';
                    
                    fieldTipoOper.datasource.get().then(() => {
                      LoadingService.hide();
                    });
                  }
                } else {
                  fieldTipoOper.datasource.filter.P_CDTIPOOPER = '02';
                  fieldTipoOper.datasource.filter.P_IDORIGDESTOP = 'L';
                  
                  fieldTipoOper.datasource.get().then(() => {
                    LoadingService.hide();
                  });
                }
                fieldTipoOper.readonly = false;
              }
            });
          });
        });
      }, 1000);
    } else {
      LoadingService.hide();
      
      AlertService.show({
        top: true,
        right: true,
        timeout: 1000,
        name: 'notCheckedAltert',
        text: 'Deve ser marcado pelo menos uma unidade para a geração de saída.',
        color: 'error',
      });
    }
  }

  public fecharModalGerarDocumento() {
    this.gerarDocumentoModal.hide();
  }
  
  public fecharModalErrosSaida() {
    this.errosSaidaModal.hide();
  }

  public selectRowsFormulario() {
    const gridProduto = Metadata.getInstance<IGridEvent>('gridSaidasOPL');
    const arrayGrid = gridProduto.datasource.currentRowValue;
    return arrayGrid;
  }

  public selectRowslancGerado() {
    const gridNotaFiscal = Metadata.getInstance<IGridEvent>('grid-formulario-OPL');
    const arrayGrid = gridNotaFiscal.datasource.currentRowValue;
    return arrayGrid;
  }

  public salvarModalGerarDocumento() {
    const grid = Metadata.getInstance<TekGrid>('gridSaidasOPL');
    const rows = grid.selectedRows;
    const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
    const valid = form.validate();
    const row = {
      NFS: rows,
      DADOSGERACAO: form.value,
    };
    
    row.DADOSGERACAO.CDFILIOPELOG = this.filterValueCDFILIOPELOG.CDFILIAL;
    row.DADOSGERACAO.SUBGRUPO = this.filterRowPrincipal.P_SUBGRUPO;
    row.DADOSGERACAO.DATAENT = this.filterRowPrincipal.P_DATAENT;
    row.DADOSGERACAO.DTENTREGA = this.filterRowPrincipal.P_DTENTREGA;
    row.DADOSGERACAO.PEDOLEXTR = this.filterRowPrincipal.P_PEDOLEXTR;
    row.DADOSGERACAO.CDLOTENVITOL = this.filterRowPrincipal.P_CDLOTENVIOL;
    row.DADOSGERACAO.IDUTILCONSSOLIOL = this.filterRowPrincipal.P_IDUTILCONSSOLIOL;
    row.DADOSGERACAO.IDUTRESPEDXOL = this.filterValueIDUTILCONSSOLIOL.data.data[0].IDUTRESPEDEXOL;
    row.DADOSGERACAO.GERANF = 'S';
    
    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();
      
      LoadingService.show('Carregando...');
      
      // valida itens do pedido e gera a nota de saida
      
      Http.post('/validaItensPedido', { requestType: 'Row', row }).then((resp) => {
        if (resp.data.dataset.pedErros.length === 0) {
          LoadingService.hide();
        } else {
          this.errosSaidaModal.show();
          
          setTimeout(() => {
            const gridErros = Metadata.getInstance<TekGrid>('gridErrosGeracaoSaida');
            
            gridErros.datasource.data = [];
            
            (gridErros as any).datasource.allData = [];
            
            gridErros.datasource.post(resp.data.dataset.pedErros).then(() => {
              gridErros.datasource.get();
              
              LoadingService.hide();
            });
          }, 1);
        }
      });
    }
  }
  
  public getConditionalCssClassIdStatus(row: IDictionary<any>) {
    if (row.IDSTATUS === '1') {
      return {
        cssClass: 'yellow-row',
      };
    }
    if (row.IDSTATUS === '2') {
      return {
        cssClass: 'green-row',
      };
    }
    return {};
  }
  
  public changeValueOfLote({ row }: IDictionary<any>) {
    if (row.CDLOTENVITOL === 'T') {
      row.CDLOTENVITOL = 'Sem Lote';
    }
  }
  
  get isVisibleGridSaidasOPL() {
    return !this.showTabOtherGrids;
  }
  
  public cellClick(params: any) {
    this.showTabOtherGrids = true;
    
    this.isLoadingDefault = false;
    
    this.orderDescription = String(params.row.NRAUTOFORN).concat(String(' - Unidade: ').concat(params.row.DSFILIAL));
    
    this.loadGridFormulario(params);
    this.loadGridLancamentoGerado(params);
  }
  
  public clickBackToPrincipalGrid() {
    this.showTabOtherGrids = false;
  }
  
  public async verifyDtProcessa({ component }: IEventParam<any>) {
    const row = {
      CDFILIOPELOG: this.filterValueCDFILIOPELOG.CDFILIAL,
      DTENTRSAID: component.value !== null ? component.value : this.filterValueDTENTREGA,
    };
    
    LoadingService.show('Carregando...');
    
    await Http.post('getDtProcessaOpl', { requestType: 'Row', row }).then((resp) => {
      if (resp.data.dataset.res !== undefined) {
        if (resp.data.dataset.res[0].MESSAGE === 'Data_Mai') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'Data_Mai',
            text: 'Data informada não deve ser maior que a data de processamento.',
            color: 'warning',
          });
          
          component.value = resp.data.dataset.res[1].DTPROCESSA;
        }
        if (resp.data.dataset.res[0].MESSAGE === 'Data_Men') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'Data_Men',
            text: 'Data informada não deve ser menor que a data de processamento.',
            color: 'warning',
          });
          
          component.value = resp.data.dataset.res[1].DTPROCESSA;
        }
        if (resp.data.dataset.res[0].MESSAGE === 'Data_M') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'Data_M',
            text: 'Data informada fora do período permitido',
            color: 'warning',
          });
          
          component.value = resp.data.dataset.res[1].DTPROCESSA;
        }
      }
      
      LoadingService.hide();
    });
  }
}
